//------------------------------------------------
// main.cpp,settingdlg.cpp ̋ʃwb_t@C

#ifndef LOCKON_MAINH
#define LOCKON_MAINH

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <math.h>
#include "resource.h"
#include "common.h"

#define WS_EX_LAYERED 0x80000
#define LWA_COLORKEY	1
#define LWA_ALPHA		2

#define MUTEX_LOCKON "MUTEX_LOCKON"   // mutex

// CvV[W
LRESULT CALLBACK MainProc(HWND, UINT, WPARAM, LPARAM);

// ̑̃vV[W
LRESULT CALLBACK FileProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CommandSettingProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK EasyTimerProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK StopTimerProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ReserveProc(HWND, UINT, WPARAM, LPARAM,WORD);
LRESULT CALLBACK TimerSetProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SettingProcAtRecording(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);


// `֌W(draw.cpp)
VOID SetMainWindow(HWND,HINSTANCE);
VOID InitScreenDraw(HWND,HINSTANCE,LPLOCKONDATA,HDC,HDC);
VOID ShowStatus(HWND,HDC,LPSTR,HDC,COLORREF);
VOID ShowCurrentTime(HDC,HDC,LPSTR,LPLOCKONDATA,BOOL);
VOID DrawMyButton(HWND,UINT,HDC,RECT,UINT,HICON*,BOOL,HDC);
VOID SetTitle(HWND,HDC,HDC,LPSTR,BOOL,BOOL);
VOID SetInfoStr(LPSTR lpszInfo, // != NULL ̎̕\,
			   BOOL bUseJapanese,
			   HDC hBufDC,HDC hBufDC2,LPLOCKONDATA lpLod);

VOID SetPlayFileInfo(HWND hWnd,HDC hBufDC,
				 WORD wFileType,
				 WAVEFORMATEX waveFmt,
				 LONGLONG n64FileSize,
				 DWORD dwFileTime,
				 DWORD dwCurTime,
				 BOOL bTimeView,
				 HDC hBufDC2,
				 COLORREF fontColor);

VOID SetRecStatus(HWND hWnd,HDC hBufDC,HDC hBufDC2,
				  WAVEFORMATEX waveFmt, 
				  WORD wForceMono,
				  DWORD dwRecTime, // b
				  BOOL bStayOnTop,
				  WORD wSaveMode,
				  BOOL bTimeView,BOOL bChain,
				  COLORREF fontColor);


VOID SetRecordingInfo(HWND hWnd,HDC hBufDC,
					  WORD wCurStatus,
					  LONGLONG n64CurDataSize,
					  LONGLONG n64CurRealDataSize,
					  DWORD dwCurTime, // b
					  DWORD dwRecTime, // b
					  BOOL bTimeView,
					  WORD wSaveMode,
					  HDC hBufDC2,
					  BOOL bPause,
					  WAVEFORMATEX waveFmt,
					  double dLevel[2],
					  double dPeak[2],
					  COLORREF fontColor);


VOID DrawLevelMeter(double dLevel[2],
			   double dPeak[2],
			   double dMaxPeak[2],
			   WAVEFORMATEX waveFmt,
			   HWND hWnd,
			   HDC hBufDC,
			   HDC hBufDC2,
			   COLORREF fontColor
			   );

// bZ[W{bNX
int MyMessageBox(HWND,LPSTR,LPSTR,UINT);
int MyMessageBoxProgress(HWND,LPSTR,LPSTR,UINT,DWORD);
VOID PrepareMsgBox();
VOID UnPrepareMsgBox();


// wavefunc.cpp ̊֐
UINT GetWaveInDevCap(LPWAVEINCAPS,UINT);
UINT GetWaveOutDevCap(LPWAVEOUTCAPS,UINT);

void SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,
				DWORD waveRate,	WORD waveBit, WORD wTag);


// commonfunc.cpp ̊֐
void GetDataSize(WAVEFORMATEX waveFmt,DWORD dwRecTime, LONGLONG* lpn64Size);
int GetArgv(char* lpszCmdLine,char argv[MAX_ARGC][CHR_BUF],int start_pos);
BOOL ShortToLongName(LPSTR);
DWORD GetFreeMemSpace(LPDWORD);
VOID GetFreeHddSpace64(ULONGLONG*,LPSTR);
LONG SetScrBarInfo(HWND,LPSCROLLINFO,WPARAM);
int ShowSettingPropSheet(HWND,HINSTANCE);
LPSTR GetFileName(LPSTR);
VOID SetChainFileName(LPSTR,LPSTR,WORD);
BOOL OnNcHitTest(HWND,LONG,LONG);
VOID SetMyScrollBar(HWND,LPSCROLLINFO,BOOL);
VOID ShowHelp(HWND);
BOOL ShowVolumeControl(HWND hWnd,UINT uCtrl);
VOID MakeLockOnShortCut(BOOL,BOOL,BOOL);
HWND GetPreLockOnHWND();
VOID SetDlgCenter(HWND);
LRESULT CALLBACK StopTimerSetProc(HWND, UINT, WPARAM, LPARAM);
BOOL ExecCommand(LPSTR,PROCESS_INFORMATION*,BOOL);
UINT ClickRButton(HWND,LPPRERECFILE,LPPRERECFOLDER);
VOID OpenCurrentFolder(HWND,LPSTR);
VOID OpenLockonFolder(HWND);
BOOL CheckSameFolder(LPSTR,LPSTR);
VOID SetFileToCurrentDir(LPSTR lpszFileName);
int ShowProperty(HWND hWnd,LPSTR szRecFile,LPLOCKONDATA lpLod,LPPIPEEXECOMDATA lpComData);
VOID SetCommandStrings(BOOL bCommand,
					   BOOL bFstdin,  // fstdin ʂǂ
					   LPSTR lpszCommand, // output
					   LPSTR lpszCommandIn, // input
					   LPSTR lpszFile,     // t@C
					   LPSTR lpszUserDef1, // [U[`
					   LPSTR lpszUserDef2,
					   LPSTR lpszUserDef3,
					   SYSTEMTIME sysTime,
					   WAVEFORMATEX waveFmt,
					   LONGLONG n64DataSize
#ifndef DEF_WAVEFLT
					   ,HWND hWnd,  // bÑEBhEnh
					   DWORD dwRecTime, // ^(b) : n64FileSize = 0 ̂ƂAgăTCYvZ
					   BOOL bOpenConsole, // pCv^ɃR\[J
					   WORD wSaveMode // Z[u[h
#endif
					   );

LPCSTR myfcvt(double val,
			  long n,    // Ŝ̌(܂)
			  long count // _ȉ̌
			  );


void WINAPI ExecLockonAtWakeUp(LPVOID lpVoid);

WORD SetPlayWaveFile(HWND hWnd,HWND hScrWnd,
					 HDC hBufDC,HDC hBufDC2,
					 LPSTR lpszFileName,
					 LPSCROLLINFO lpScrInfo,
					 LPWAVEFORMATEX lpPlayWaveFmt,
					 WAVEFORMATEX recWaveFmt,
					 WORD wForceMono,
					 WORD wSaveMode,
					 LPDWORD lpdwWaveTime,
					 LONGLONG* lpn64FileSize,
					 DWORD dwRecTime,
					 BOOL bStayOnTop,BOOL bTimeView,
					 BOOL bUseBgBitmap,BOOL bShowPath,
					 BOOL bChain,
					 BOOL bReset,
					 COLORREF fontColor);

int ShowThreadInfo(HWND hWnd);


// I_CAO֌W(selectdlg.cpp)
BOOL SelectRGBColor(HWND,LPCOLORREF);
BOOL SelectWaveFile(HWND,LPSTR);
BOOL SelectBmpFile(HWND,LPSTR);
BOOL SelectExeFile(HWND,LPSTR);
BOOL SelectExeBatFile(HWND,LPSTR);


// ݒt@C֌W(file.cpp)
VOID ReadIniFile(LPLOCKONDATA,LPPIPEEXECOMDATA,LPCSTR,LPCSTR,LPCSTR);
VOID SaveIniFile(LPLOCKONDATA,LPPIPEEXECOMDATA,LPCSTR,LPCSTR,LPCSTR);


// ^C}[A\֌W(reserve.cpp)
int ShowReserveDlg(HWND,LPLOCKONDATA,LPRESERVEDATA,LPPIPEEXECOMDATA,LPDWORD,BOOL);
WORD CheckEnableReserve(HWND,LPLOCKONDATA,LPRESERVEDATA,LPWAVEINCAPS,UINT,BOOL);
VOID SaveReserveFile(LPSTR,LPRESERVEDATA);
VOID ReadReserveFile(LPSTR,LPRESERVEDATA);
LRESULT CALLBACK ReserveTimeSettingProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);
BOOL SetReserveWaitableTimer(HWND hWnd,
							 LPLOCKONDATA lpLod,
							LPRESERVEDATA lpResData,
							DWORD dwOffsetSec 
							);
int ShowResPropSheet(HWND hWnd,HINSTANCE hInst,LPRESERVEDATA lpResData,LONG nStartPage);
BOOL CheckReserveTime(LPRESERVEDATA lpResData,
					   DWORD dwNum, // \ԍ
					  int nPrepareTime // 0 ` 3600 b
					  );
BOOL GetNearestReserveNumber(LPLOCKONDATA lpLod,
							LPRESERVEDATA lpResData,
							DWORD dwOffsetSec,

							LPDWORD lpdwNear, // out
							SYSTEMTIME* lpstNearest // out
							);

// Đ֌W
VOID SeekPlayWave(DWORD);
VOID StopPlayWave();
BOOL PlayWave(HWND hWnd,UINT uDeviceID,LPSTR lpszFileName,DWORD dwTime,
			  HANDLE hdFile,WAVEFORMATEX waveFmt,
			  LONGLONG n64WaveDataSize, // t@C̃TCY
			  LONGLONG n64WaveOffset  // f[^܂ł̃ItZbg 
			  );

// ^֌WS(recording.cpp)
BOOL CheckFileOverWrite(HWND,LPSTR,BOOL);
DWORD CalcBufBlockSize(DWORD,WAVEFORMATEX);
VOID SetEditFreeSize(HWND,LPSTR);
BOOL PrepareRecording(HWND hWnd,
					  LPSTR lpszFileName,
					  WAVEFORMATEX waveFmt,
					  LPWORD lpwSaveMode,
					  DWORD dwRecTime,
					  LPWAVEINCAPS waveInCaps,
					  UINT uRecDevID,
					  BOOL bMsg   // bZ[W\邩
					  );

BOOL StartRecording(HWND hWnd,HWND hScrWnd,HDC hBufDC,HDC hBufDC2,
					LPSTR lpszFileName,
					LPSTR lpszPipeCom, // pCvR}h
					LPSTR lpszAftCom,  // ^ɎsR}h
					BOOL bHeaderOffPipe, // PIPEwb_𑗂Ȃ
					LPSCROLLINFO lpScrInfo,
					WAVEFORMATEX waveFmt,
					LPWORD lpwSaveMode,  // Z[u[h
					WORD wForceMono,     // m[h
					DWORD dwRecTime, // ^(b)
					DWORD dwWaveBlockByte,
					BOOL bPauseRec,
					BOOL bMsg,  // bZ[W\邩
					LPLOCKONDATA lpLod,
					DWORD dwCurRecNum, // ^ԍ
					BOOL bClose, // ^I
					DWORD dwMouseMoveTime
					);

// HDD,PIPE ^֌W (recwave.cpp)
BOOL StopRecWaveAll(HWND,WORD);
VOID ForcedStopRecWaveAll(HWND);
BOOL PauseRecWave(BOOL);
VOID PrepareRecWave();
VOID UnPrepareRecWave();
void SetPipeDebugMode();
BOOL RecWave(HWND hWnd,UINT uDeviceID,LPSTR lpszFileName,WAVEFORMATEX waveFmt,
			 WORD wWaveHdrNumber,
			 DWORD dwWaveBlockByte,
			 DWORD dwRecTime, // ^(b)
			 WORD threadPriority,BOOL bDiskCache,BOOL bPauseRec,BOOL bMarginCheck,
			 BOOL fSave,
			 WORD wSaveMode,
			 WORD wForceMono,
			 LPSTR lpszPipeCom,
			 LPSTR lpszAftCom,
			 DWORD dwAftComWait,
			 BOOL bOpenConsole,
			 DWORD dwPipeSize,
			 BOOL bHeaderOffPipe, // PIPEwb_𑗂Ȃ
			 BOOL bAdjustWriteTime, // ^ = XVԂɃZbg
			 DWORD dwWimNum, // WIM_DATA őԍ
			 BOOL bClose,	// ^I邩ǂ
			 DWORD dwMouseMoveTime // Ŏw肵b̊ԃ}EX͂΃R}hs
			 );

DWORD CheckThreadMoving();
DWORD GetNoMovingThreadID();
BOOL GetThreadInfo(LPRECTHREADDATA lpThDat,DWORD dwThread);


// Window ֌W
BOOL PrepareLayeredWindow(HWND); 
BOOL MySetLayeredWindowAttributes(HWND,COLORREF,BYTE,DWORD);
VOID UnprepareLayeredWindow();


// Waitable Timer (timer.cpp)
BOOL InitWaitableTimer();
VOID ResetWaitableTimer(HWND);
BOOL CanUseWaitableTimer();
EXECUTION_STATE MySetThreadExecutionState();


// log
void SetLog(BOOL bSet);
BOOL IfSetLog();
void WriteLog(char* szLog);
void ViewLog();
VOID PrepareLog();
VOID UnPrepareLog();


// MP3 Đ֌W
BOOL PrepareMP3();
BOOL UnPrepareMP3();
BOOL PlayMP3(HWND,LPSTR,DWORD,UINT);
VOID SeekPlayMP3(DWORD);
VOID StopPlayMP3();


// OGG
BOOL PrepareOGG();
BOOL UnPrepareOGG();
BOOL PlayOGG(HWND,LPSTR,DWORD,UINT);
VOID SeekPlayOGG(DWORD);
VOID StopPlayOGG();


#endif
// EOF

