//----------------------------------------
// WAVE ֌W()
//
// (c) 1998-2002 tokai@main.eng.hokudai.ac.jp
//
// {vÔׂāA܂͈ꕔ GPL ɏ]čĔЕz܂͕ύX
// Ƃł܂BڍׂɂĂGNU ʌLgpǂ݂B
//

#include <windows.h>
#include <mmsystem.h>
#include <math.h>
#include "wave.h"

#define CHR_BUF 256
#define USEWIN32API

// bZ[W{bNX
int MyMessageBox(HWND,LPSTR,LPSTR,UINT);


//-------------------------------------------------------------------
// set WAVE format
void SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,
				DWORD waveRate,	WORD waveBit, WORD wTag)
{
	
	lpWaveFmt->wFormatTag = wTag;
	lpWaveFmt->nChannels = waveChn;  
	lpWaveFmt->nSamplesPerSec = waveRate; 
	lpWaveFmt->nAvgBytesPerSec = (DWORD)(waveRate*waveChn*waveBit/8); // byte/sec
	lpWaveFmt->nBlockAlign = (WORD)(waveChn*waveBit/8); // byte/block
	lpWaveFmt->wBitsPerSample = waveBit; 
	lpWaveFmt->cbSize = (WORD)0; // no extention
}



//-------------------------------------------------------------------
// wave wb_̃obt@Zbg֐
BOOL SetWaveHdr(HWND hWnd,LPWAVEHDR lpWaveHdr, LONG nHdrNumber,DWORD dwWaveBlockByte)
{
	LONG i;
	LPBYTE lpWaveData;
	
	// obt@m
	lpWaveData =(LPBYTE)GlobalAlloc(GPTR,sizeof(BYTE)*dwWaveBlockByte*nHdrNumber);
	
	if(lpWaveData == NULL){
		MyMessageBox(hWnd, "̊mۂɎs܂B",
			"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
		return FALSE;
	}
	
	// wave wb_[ݒ
	for(i=0;i<nHdrNumber;i++){
		memset(&lpWaveHdr[i], 0, sizeof(WAVEHDR));
		lpWaveHdr[i].lpData  = (LPSTR)lpWaveData+dwWaveBlockByte*i;	// f[^i[̈m
		lpWaveHdr[i].dwBufferLength = dwWaveBlockByte; // f[^TCY
	}
	
	return TRUE;
}


//-------------------------------------------------------------------
// wave wb_̃obt@Zbg֐̃q[v
BOOL SetHeapWaveHdr(HWND hWnd,HANDLE hHeap,
					LPBYTE* lppDat,  // Ɨ̈p
					LPWAVEHDR lpWaveHdr, 
					LONG nHdrNumber,
					DWORD dwWaveBlockByte)
{
	LONG i;
	LPBYTE lpWaveData;
	
	// obt@m
	lpWaveData = (LPBYTE)HeapAlloc(hHeap,HEAP_ZERO_MEMORY,
		sizeof(BYTE)*dwWaveBlockByte*(nHdrNumber+1)
		);
	
	if(lpWaveData == NULL){
		MyMessageBox(hWnd, "̊mۂɎs܂B",
			"Error", MB_OK|MB_ICONERROR);
		
		return FALSE;
	}
	
	// wave wb_[ݒ
	for(i=0;i<nHdrNumber;i++){
		memset(&lpWaveHdr[i], 0, sizeof(WAVEHDR));
		lpWaveHdr[i].lpData  = (LPSTR)lpWaveData+dwWaveBlockByte*i;	// f[^i[̈m
		lpWaveHdr[i].dwBufferLength = dwWaveBlockByte; // f[^TCY
	}

	// Ɨ̈p
	if(lppDat) *lppDat = lpWaveData+dwWaveBlockByte*i;
	
	return TRUE;
}


//-------------------------------------------------------------------
// wave wb_̃obt@폜֐
BOOL DelWaveHdr(HWND hWnd,LPWAVEHDR lpWaveHdr)
{
	
	if(lpWaveHdr[0].lpData != NULL){
		if(GlobalFree(lpWaveHdr[0].lpData)!=NULL){
			MyMessageBox(hWnd, "̊JɎs܂B",
				"Error", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			return FALSE;
		}
		else lpWaveHdr[0].lpData=NULL;
	}
	
	return TRUE;
}




//-------------------------------------
// search for head of chunk, 
BOOL SearchChunk(HANDLE hdFile,char* szChunk, DWORD dwSize, 
				 BOOL bGetChkSize, // get chunk size
				 BOOL bStdin, // no seek
				 LPDWORD lpdwChkSize,LPDWORD lpdwOffset){

	DWORD dwPoint;
	DWORD dwByte;
	BYTE byteRead;
	char szCheck[5];
#ifdef USEWIN32API
	LARGE_INTEGER LI; 
#endif

	memset(szCheck,0,5);
	for(dwPoint = 0; dwPoint < dwSize; dwPoint++){
		
		if(!bStdin){
#ifdef USEWIN32API 
			LI.QuadPart = dwPoint;
			SetFilePointer(hdFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
#else
			fseek(hdFile,dwPoint,SEEK_SET);
#endif
		}
		
#ifdef USEWIN32API 
		ReadFile(hdFile,&byteRead,1,&dwByte, NULL);
#else  
		dwByte = fread(&byteRead,1,1,hdFile);
#endif
		if(dwByte != 1) return false;
		*lpdwOffset += dwByte;  

		if(byteRead == szChunk[0]){
			
#ifdef USEWIN32API 
			ReadFile(hdFile,szCheck,3,&dwByte, NULL);
#else  
			dwByte = fread(szCheck,1,3,hdFile);
#endif
			if(dwByte != 3) return false;
			*lpdwOffset += dwByte;  
			
			if(strcmp(szCheck,szChunk+1)==0) break;
		}

	}
	
	if(dwPoint == dwSize) return false;

	// chunk size
	if(bGetChkSize){
#ifdef USEWIN32API 
		ReadFile(hdFile,lpdwChkSize,sizeof(DWORD),&dwByte, NULL);
#else  
		dwByte = fread(lpdwChkSize,1,sizeof(DWORD),hdFile);
#endif
		if(dwByte != sizeof(DWORD)) return false;
		*lpdwOffset += dwByte;  
	}

	if(!bStdin){
		*lpdwOffset = dwPoint + 4;
		if(bGetChkSize) *lpdwOffset += sizeof(DWORD);
	}


	return true;
}



//------------------------------------------------------------------
// check whether format is valid
BOOL CheckWaveFormat(LPWAVEFORMATEX lpWaveFmt,char* lpszErr){

	DWORD waveRate,avgByte;	
	WORD waveChn,waveBit;

	if(lpWaveFmt->wFormatTag != WAVE_FORMAT_IEEE_FLOAT 
		|| lpWaveFmt->wFormatTag != WAVE_FORMAT_PCM // 
		){
		if(lpszErr) strcpy(lpszErr,"This data is not PCM format.\n");
	}
	
	waveChn = lpWaveFmt->nChannels;  
	waveRate = lpWaveFmt->nSamplesPerSec; 
	waveBit = lpWaveFmt->wBitsPerSample; 
	avgByte = lpWaveFmt->nAvgBytesPerSec; 

	if(waveChn != 1 && waveChn != 2){
		if(lpszErr) wsprintf(lpszErr,"'%d channel' is not supported.\n",waveChn);
		return false;
	}	

	if(waveBit != 8 && waveBit != 16 && waveBit != 24 && waveBit != 32 && waveBit != 64){
		if(lpszErr) wsprintf(lpszErr,"'%d bit' is not supported.\n",waveBit);
		return false;
	}
	
	if(avgByte != waveChn*waveRate*waveBit/8){
		if(lpszErr) strcpy(lpszErr,"Wave format is broken.\n");
		return false;
	}

	return true;
}


//-------------------------------------------------------------------
// get WAVE format and time, etc.   5/18/2002
BOOL GetWaveFormat(char* lpszFileName, // file name or 'stdin'
				   LPWAVEFORMATEX lpWaveFmt, 
				   LONGLONG* lpn64WaveDataSize, // size of data
				   LONGLONG* lpn64WaveOffset, // offset to data chunk
				   char* lpszErr 
				   )
{
	
#ifdef USEWIN32API
	HANDLE hdFile;
#else
	FILE* hdFile;
#endif
	DWORD dwCkSize; // chunk size
	DWORD dwByte;
	DWORD dwOffset; // offset to data
		
	char szErr[CHR_BUF];
	BOOL bStdin = false;
	LONGLONG n64DataSize;

	n64DataSize = 0;
	
	// open file
	if(strcmp(lpszFileName,"stdin")==0) bStdin = true;
	
	if(bStdin){ // stdin
		
#ifdef USEWIN32API
		hdFile	= GetStdHandle(STD_INPUT_HANDLE); 
#else
		hdFile = stdin;
#ifdef WIN32
		_setmode(_fileno(stdin),_O_BINARY); // binary mode
#endif
		
#endif
	}
	else{ // file
		
#ifdef USEWIN32API
		hdFile = CreateFile(lpszFileName,GENERIC_READ, 0, 0,OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL);
		if(hdFile == INVALID_HANDLE_VALUE){
			 wsprintf(szErr,"Could not open '%s'\n",lpszFileName);
			goto L_ERR;
		}						
#else
		hdFile = fopen(lpszFileName,"rb");
		if(hdFile == NULL) {
			wsprintf(szErr,"Could not open '%s'\n",lpszFileName);
			goto L_ERR;
		}	
#endif		
	}
	

	//------------------------------------------------------

	dwOffset = 0;
	
	// is this file 'RIFF' format?
	if(!SearchChunk(hdFile,"RIFF",4,true,bStdin,&dwCkSize,&dwOffset)){
		strcpy(szErr,"Could not find 'RIFF'. This is not wave file.\n");
		goto L_ERR;	
	}


	//--------------------------
	
	// search for 'WAVE'
	if(!SearchChunk(hdFile,"WAVE",128,false,bStdin,&dwCkSize,&dwOffset)){
		strcpy(szErr,"Wave header may be broken.\n");
		goto L_ERR;	
	}
	
	//--------------------------
	// format chunk

	// search for 'fmt_'
	if(!SearchChunk(hdFile,"fmt ",128,true,bStdin,&dwCkSize,&dwOffset)){
		strcpy(szErr,"Wave header may be broken.\n");
		goto L_ERR;	
	}

	// get format
#ifdef USEWIN32API 
	ReadFile(hdFile,lpWaveFmt,dwCkSize,&dwByte, NULL);
#else  
	dwByte = fread(lpWaveFmt,1,dwCkSize,hdFile);
#endif
	if(dwByte != dwCkSize){
		strcpy(szErr,"Wave header may be broken.\n");
		goto L_ERR;
	}
	dwOffset += dwByte;  
	
	// set cbSize to  0 
	lpWaveFmt->cbSize = 0; 
	
	// check format tag
	if(!CheckWaveFormat(lpWaveFmt,szErr)) goto L_ERR;

	//--------------------------
	// waveflt chunk (extra chunk)
	
	if(!bStdin){ // when stdin, endless mode is set, so ignore data size

		// search for 'wflt'
		if(SearchChunk(hdFile,"wflt",128,true,bStdin,&dwCkSize,&dwOffset)){

			// get file size
#ifdef USEWIN32API 
			ReadFile(hdFile,&n64DataSize,sizeof(LONGLONG),&dwByte, NULL);
#else  
			dwByte = fread(&n64DataSize,1,sizeof(LONGLONG),hdFile);
#endif
			if(dwByte != sizeof(LONGLONG)){
				strcpy(szErr,"Wave header may be broken.\n");
				goto L_ERR;
			}
			dwOffset += dwByte;  
			
			*lpn64WaveDataSize = n64DataSize;
		}
	}


	//--------------------------
	// data chunk

	// search for 'data'
	if(!SearchChunk(hdFile,"data",128,true,bStdin,&dwCkSize,&dwOffset)){
		strcpy(szErr,"Wave header may be broken.\n");
		goto L_ERR;	
	}
	
	if(lpn64WaveDataSize && n64DataSize == 0) *lpn64WaveDataSize = dwCkSize;
	
	// offset to data
	if(lpn64WaveOffset) *lpn64WaveOffset = dwOffset;

	// close handle
	if(!bStdin){
#ifdef USEWIN32API 
		CloseHandle(hdFile);
#else
		fclose(hdFile);
#endif
	}

	return true;
	
	//------------------------

L_ERR: 
	
	if(!bStdin){
#ifdef USEWIN32API 
		CloseHandle(hdFile);
#else
		fclose(hdFile);
#endif
	}
	if(lpszErr) strcpy(lpszErr,szErr);
	
	return false;
	
}


//-------------------------------------------------------------------
// change byte-data to double-data 
void WaveLevel(double dLevel[2],  // output of left and right
			   BYTE* lpWaveData,  // input
			   WAVEFORMATEX waveFmt){ 
	
	long i;
	short data[2];
	long nData[2];
	double dData[2];
	float fData[2];

	nData[1] = 0;
	
	if(waveFmt.wBitsPerSample==8){ // 8 bit
		for(i=0;i<waveFmt.nChannels;i++) nData[i] = (long)lpWaveData[i]-0x80;
	}
	else if(waveFmt.wBitsPerSample==16){	// 16 bit
		memcpy(data,lpWaveData,sizeof(short)*waveFmt.nChannels);
		nData[0] = (long)data[0];
		nData[1] = (long)data[1];
	}
	else if(waveFmt.wBitsPerSample==24){	// 24 bit
		for(i=0;i<waveFmt.nChannels;i++){
			nData[i] = 0;
			memcpy((LPBYTE)(nData+i)+1,lpWaveData+3*i,3);
			nData[i] /= 256;
		}
	}
	else if(waveFmt.wBitsPerSample==32 && waveFmt.wFormatTag == WAVE_FORMAT_PCM){	// 32 bit long
		memcpy(nData,lpWaveData,sizeof(long)*waveFmt.nChannels);
	}
	else if(waveFmt.wBitsPerSample==32 && waveFmt.wFormatTag == WAVE_FORMAT_IEEE_FLOAT){	// 32 bit float
		memcpy(fData,lpWaveData,sizeof(double)*waveFmt.nChannels);
		dLevel[0] = fData[0];
		dLevel[1] = fData[1];
		return;
	}	
	else if(waveFmt.wBitsPerSample==64){	// 64 bit double
		memcpy(dData,lpWaveData,sizeof(double)*waveFmt.nChannels);
		dLevel[0] = dData[0];
		dLevel[1] = dData[1];
		return;
	}

	dLevel[0] = (double)nData[0];
	dLevel[1] = (double)nData[1];
}




//-----------------------------------------------
// get max level of wave 
double GetMaxWaveLevel(WAVEFORMATEX waveFmt){

	double dRet;

	switch(waveFmt.wBitsPerSample){
	case 8: dRet = 127; break;
	case 16: dRet = 32767; break;
	case 24: dRet = 8388607; break;
	case 64: dRet = 1; break;
	case 32: 
		if(waveFmt.wFormatTag == WAVE_FORMAT_PCM) dRet = 2147483647;
		else dRet = 1;
		break;
	}

	return dRet;

}


//-------------------------------------------------------------------
// obt@̒ōős[N
// -1 < < 1 ŐKĕԂ
VOID WaveLevelMaxPeak(double dPeak[2],
					  LPBYTE lpWaveData,  // data
					  DWORD dwWaveBlockByte, // byte, size of data
					  WAVEFORMATEX waveFmt){ 
	
	DWORD i;
	double dLevel[2];
	double dMaxLevel;
	
	dPeak[0] = dPeak[1] = 0;
	dMaxLevel = GetMaxWaveLevel(waveFmt);
	
	for(i = 0; i < dwWaveBlockByte; i+=waveFmt.nBlockAlign*16){
		WaveLevel(dLevel,lpWaveData+i,waveFmt);
		dPeak[0] = max(dPeak[0], fabs(dLevel[0])/dMaxLevel);
		dPeak[1] = max(dPeak[1], fabs(dLevel[1])/dMaxLevel);
	}

	if(waveFmt.nChannels == 1) dPeak[1] = 0;

}



//-------------------------------------------
// wave wb_o
VOID WriteWaveHeader(HANDLE hdWriteFile,LPWAVEFORMATEX lpWaveFmt,LONGLONG n64WaveDataSize
					 ,BOOL bUseExtChunk)
{
	
	DWORD dwFoo;
	DWORD dwByte; 
	LARGE_INTEGER LI; 
	DWORD dwFileType;
	DWORD dwHeadSize;

	dwHeadSize = WAVEHDRSIZE(bUseExtChunk);

	if(hdWriteFile == NULL) return;

	// get type of file
	dwFileType = GetFileType(hdWriteFile);
	
	// move file pointer
	if(dwFileType != FILE_TYPE_PIPE){
		LI.QuadPart = 0;
		SetFilePointer(hdWriteFile,LI.LowPart, &LI.HighPart,FILE_BEGIN);
	}
	
	// RIFF (8)
	WriteFile(hdWriteFile, "RIFF",4, &dwByte, NULL);
	if(n64WaveDataSize >= 0xFFFFFFFF-dwHeadSize+8) dwFoo = 0xFFFFFFFF; // = 4G
	else dwFoo = ((DWORD)n64WaveDataSize + dwHeadSize) - 8;
	WriteFile(hdWriteFile, &dwFoo,sizeof(DWORD), &dwByte, NULL);

	// WAVE (4)
	WriteFile(hdWriteFile, "WAVE",4, &dwByte, NULL);

	// format chunk (24)
	WriteFile(hdWriteFile, "fmt ",4, &dwByte, NULL);
	dwFoo = 16;
	WriteFile(hdWriteFile, &dwFoo,sizeof(DWORD), &dwByte, NULL);
	WriteFile(hdWriteFile, lpWaveFmt, sizeof(WAVEFORMATEX)-sizeof(WORD), &dwByte, NULL);
	
	// waveflt chunk (extra chunk)
	if(bUseExtChunk){
			WriteFile(hdWriteFile, "wflt",4, &dwByte, NULL);
			dwFoo = sizeof(LONGLONG) + sizeof(DWORD);
			WriteFile(hdWriteFile, &dwFoo,sizeof(DWORD), &dwByte, NULL);
			WriteFile(hdWriteFile, &n64WaveDataSize, sizeof(LONGLONG), &dwByte, NULL);
			dwFoo = 0;
			WriteFile(hdWriteFile, &dwFoo,sizeof(DWORD), &dwByte, NULL);
	}

	
	// data chunk (8  + datasize)
	WriteFile(hdWriteFile, "data",4, &dwByte, NULL);
	if(n64WaveDataSize >= 0xFFFFFFFF-dwHeadSize+8) dwFoo = 0xFFFFFFFF-dwHeadSize+8; // = 4G
	else dwFoo = (DWORD)n64WaveDataSize;
	WriteFile(hdWriteFile, &dwFoo,sizeof(DWORD), &dwByte, NULL);
}




//-----------------------------------------------
// ĐTEhfoCX擾
// ߂l̓foCX̐
// ̎擾ɎsfoCX wChannels  0 ɃZbg
// ܂AlpWaveOutCaps[uMaxNum-1] ɂ WAVE_MAPPER ̏񂪓
UINT GetWaveOutDevCap(LPWAVEOUTCAPS lpWaveOutCaps,UINT uMaxNum){
	
	UINT uDevNum,i;
	
	uDevNum = min(uMaxNum,waveOutGetNumDevs());
	if(uDevNum >= uMaxNum) uDevNum = uMaxNum-1;
	
	for(i=0;i<uDevNum;i++){
		if(waveOutGetDevCaps(i,&lpWaveOutCaps[i],sizeof(WAVEOUTCAPS))
			!= MMSYSERR_NOERROR) lpWaveOutCaps[i].wChannels = 0;
	}
	
	if(waveOutGetDevCaps(WAVE_MAPPER,&lpWaveOutCaps[uMaxNum-1],sizeof(WAVEOUTCAPS))
		!= MMSYSERR_NOERROR) lpWaveOutCaps[uMaxNum-1].wChannels = 0;
	
	return uDevNum;
}


//-----------------------------------------------
// ^TEhfoCX擾
// ߂l̓foCX̐
// ̎擾ɎsfoCX wChannels  0 ɃZbg
// ܂AlpWaveOutCaps[uMaxNum-1] ɂ WAVE_MAPPER ̏񂪓
UINT GetWaveInDevCap(LPWAVEINCAPS lpWaveInCaps,UINT uMaxNum){
	
	UINT uDevNum,i;
	
	uDevNum = waveInGetNumDevs();
	if(uDevNum >= uMaxNum) uDevNum = uMaxNum-1;
	
	for(i=0;i<uDevNum;i++){
		if(waveInGetDevCaps(i,&lpWaveInCaps[i],sizeof(WAVEOUTCAPS))
			!= MMSYSERR_NOERROR) lpWaveInCaps[i].wChannels = 0;
	}
	
	if(waveInGetDevCaps(WAVE_MAPPER,&lpWaveInCaps[uMaxNum-1],sizeof(WAVEOUTCAPS))
		!= MMSYSERR_NOERROR) lpWaveInCaps[uMaxNum-1].wChannels = 0;
	
	return uDevNum;
}






//--------------------------------------------------------
// copy byte data to double data
void CopyBufferBtoD(BYTE* lpBuffer,  // input, buffer (BYTE*)
						DWORD dwByte, // size of lpBuffer

						double* lpFilterBuf[2], // output, buffer of wave data (double*) (L-R)
						LPDWORD lpdwPointsInBuf, // points of data in lpFilterBuf
						WAVEFORMATEX waveFmt
						){
	
	DWORD i,dwChn,dwPos; 
	BYTE* lpBuffer2;
	LONG nVal;
	DWORD dwFilterBufSize; 

	dwFilterBufSize = dwByte / waveFmt.nBlockAlign;
	
	if(waveFmt.wBitsPerSample == 16){  // 16 bit
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			lpBuffer2 = lpBuffer+sizeof(short)*dwChn;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){
				lpFilterBuf[dwChn][dwPos] = (double)(*((short*)lpBuffer2));
				dwPos++;
				lpBuffer2 += waveFmt.nBlockAlign;
			}

		}
	}
	else if(waveFmt.wBitsPerSample == 8){ // 8 bit
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){
				lpFilterBuf[dwChn][dwPos] = (double)((int)lpBuffer[i+dwChn]-0x80);
				dwPos++;
			}
		}

	}
	else if(waveFmt.wBitsPerSample == 24){  // 24 bit
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			lpBuffer2 = lpBuffer+3*dwChn;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){

				nVal = 0;
				memcpy((LPBYTE)(&nVal)+1,lpBuffer2,3);
				nVal /= 256;

				lpFilterBuf[dwChn][dwPos] = (double)nVal;
				dwPos ++;
				lpBuffer2 += waveFmt.nBlockAlign;
			}

		}
	}
	else if(waveFmt.wBitsPerSample == 32 && waveFmt.wFormatTag == WAVE_FORMAT_PCM){  // 32 bit long
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			lpBuffer2 = lpBuffer+sizeof(long)*dwChn;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){
				lpFilterBuf[dwChn][dwPos] = (double)(*((long*)lpBuffer2));
				dwPos ++;
				lpBuffer2 += waveFmt.nBlockAlign;
			}

		}
	}
	else if(waveFmt.wBitsPerSample == 32 && waveFmt.wFormatTag == WAVE_FORMAT_IEEE_FLOAT){  // 32 bit float
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			lpBuffer2 = lpBuffer+sizeof(float)*dwChn;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){
				lpFilterBuf[dwChn][dwPos] = (double)(*((float*)lpBuffer2));
				dwPos ++;
				lpBuffer2 += waveFmt.nBlockAlign;
			}

		}
	}
	else if(waveFmt.wBitsPerSample == 64){  // 64 bit(double)
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			
			dwPos = 0;
			lpBuffer2 = lpBuffer+sizeof(double)*dwChn;
			memset(lpFilterBuf[dwChn],0,sizeof(double)*dwFilterBufSize);
			
			for(i=0;i< dwByte;i+=waveFmt.nBlockAlign){
				lpFilterBuf[dwChn][dwPos] = (double)(*((double*)lpBuffer2));
				dwPos ++;
				lpBuffer2 += waveFmt.nBlockAlign;
			}

		}
	}

	*lpdwPointsInBuf = dwByte/waveFmt.nBlockAlign;
}


//----------------------------
// copy double data to byte buffer
void CopyBufferDtoB(BYTE* lpBuffer,  // output, buffer(BYTE*)

					double* lpFilterBuf[2], // input, buffer(double*)
				  DWORD dwPointsInBuf, // points in lpFilterBuf
				  WAVEFORMATEX waveFmt,

				  DWORD* lpdwSaturate  // number of saturation
				  ){
	
	DWORD i,dwChn,dwPos; 
	BYTE* lpBuffer2;
	double dFoo,dFoo2;
	double dMaxLevel;
	long nOut;
	float fOut;
	
	// if bit == 64 or 32-float, then don't check saturation
	if(waveFmt.wBitsPerSample == 64){  // 64 bit
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			dwPos = 0;
			lpBuffer2 = lpBuffer + waveFmt.wBitsPerSample/8 * dwChn;

			for(i=0;i< dwPointsInBuf;i++,dwPos++){
				memcpy(lpBuffer2,lpFilterBuf[dwChn]+dwPos,sizeof(double));
				lpBuffer2 += waveFmt.nBlockAlign;
			}
		}
		
	}
	else if(waveFmt.wBitsPerSample == 32 && waveFmt.wFormatTag == WAVE_FORMAT_IEEE_FLOAT) // 32-float
	{ 
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){
			dwPos = 0;
			lpBuffer2 = lpBuffer + waveFmt.wBitsPerSample/8 * dwChn;

			for(i=0;i< dwPointsInBuf;i++,dwPos++){
				fOut = (float)(lpFilterBuf[dwChn][dwPos]);
				memcpy(lpBuffer2,&fOut,sizeof(float));
				lpBuffer2 += waveFmt.nBlockAlign;
			}
		}
	}
	else  // 8,16,24,32-long
	{
		dMaxLevel = GetMaxWaveLevel(waveFmt);
		
		for(dwChn = 0 ; dwChn < waveFmt.nChannels  ; dwChn++){

			dwPos = 0;
			lpBuffer2 = lpBuffer + waveFmt.wBitsPerSample/8 *dwChn;

			for(i=0;i< dwPointsInBuf;i++,dwPos++){
				
				// check saturation
				dFoo = lpFilterBuf[dwChn][dwPos];
				dFoo2 = fabs(dFoo);
				if(dFoo2 > dMaxLevel){
					if(lpdwSaturate) (*lpdwSaturate)++;
					dFoo = (dFoo > 0) ? (dMaxLevel-1) : -(dMaxLevel-1);
				}
				nOut = (LONG)dFoo;

				// copy data to buffer
				if(waveFmt.wBitsPerSample == 16) *((short*)lpBuffer2) = (short)nOut;
				else if(waveFmt.wBitsPerSample == 8) *lpBuffer2 = (BYTE)(nOut+0x80);
				else if(waveFmt.wBitsPerSample == 24) memcpy(lpBuffer2,&nOut,3);
				else if(waveFmt.wBitsPerSample == 32 && waveFmt.wFormatTag == WAVE_FORMAT_PCM) 
					memcpy(lpBuffer2,&nOut,sizeof(long)); // 32 bit long
				
				lpBuffer2 += waveFmt.nBlockAlign;
			}

			
		}
		
	}
	
}



//-------------------------------------
// change bits of data
DWORD ChangeBits(BYTE* lpBuf,  // input,output, buffer(BYTE*)
				DWORD dwByte, // byte, size of lpBuf
				WAVEFORMATEX waveFmtIn,
				WAVEFORMATEX waveFmtOut,
				double* lpFilterBuf[2]) // buffer
{

	DWORD dwPoints,i,i2,dwSat;
	double dChangeBit;

	dChangeBit = GetMaxWaveLevel(waveFmtOut);
	dChangeBit /= GetMaxWaveLevel(waveFmtIn);

	CopyBufferBtoD(lpBuf,dwByte,lpFilterBuf,&dwPoints,waveFmtIn);
	
	for(i=0;i<waveFmtIn.nChannels;i++){
		for(i2=0;i2<dwPoints;i2++){
			lpFilterBuf[i][i2] *= dChangeBit;
		}
	}

	CopyBufferDtoB(lpBuf,lpFilterBuf,dwPoints,waveFmtOut,&dwSat);


	return (dwByte/waveFmtIn.nBlockAlign*waveFmtOut.nBlockAlign);
}



//EOF