//--------------------------------------
// ʓIȊ֐
//
// (c) 1998-2003 tokai@main.eng.hokudai.ac.jp
//
// {vÔׂāA܂͈ꕔ GPL ɏ]čĔЕz܂͕ύX
// Ƃł܂BڍׂɂĂGNU ʌLgpǂ݂B
//

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "common.h"
#include "wave.h"


// recwave.cpp
DWORD CheckThreadMoving();
BOOL CheckCoreMoving();
BOOL StopRecWave(HWND hWnd,WORD wWaitTime,DWORD dwThread);

// `֌W(draw.cpp)
VOID ShowStatus(HWND,HDC,LPSTR,HDC,COLORREF);
VOID SetTitle(HWND,HDC,HDC,LPSTR,BOOL,BOOL);
VOID SetRecStatus(HWND hWnd,HDC hBufDC,HDC hBufDC2,
				  WAVEFORMATEX waveFmt, 
				  WORD wForceMono,
				  DWORD dwRecTime, // b
				  BOOL bStayOnTop,
				  WORD wSaveMode,
				  BOOL bTimeView,BOOL bChain,
				  COLORREF fontColor);
VOID SetPlayFileInfo(HWND hWnd,HDC hBufDC,
				 WORD wFileType,
				 WAVEFORMATEX waveFmt,
				 LONGLONG n64FileSize,
				 DWORD dwFileTime,
				 DWORD dwCurTime,
				 BOOL bTimeView,
				 HDC hBufDC2,
				 COLORREF fontColor);
// bZ[W{bNX
int MyMessageBox(HWND,LPSTR,LPSTR,UINT);

// I_CAO֌W(selectdlg.cpp)
BOOL SelectWaveFile(HWND,LPSTR);
BOOL SelectExeBatFile(HWND,LPSTR);

// MP3 ֌W
BOOL GetFormatMP3(HWND,LPSTR,LPWAVEFORMATEX,LPDWORD,LPDWORD);
BOOL IsReadyMP3();

// OGG
BOOL GetFormatOGG(HWND,LPSTR,LPWAVEFORMATEX,LPDWORD,LPDWORD);
BOOL IsReadyOGG(LPSTR);

// wave.cpp ̃t@C
BOOL GetThreadInfo(LPRECTHREADDATA lpThDat,DWORD dwThread);
VOID SetDlgCenter(HWND);
BOOL GetWaveFormat(char* lpszFileName, // file name or 'stdin'
				   LPWAVEFORMATEX lpWaveFmt, 
				   LONGLONG* lpn64WaveDataSize, // size of data
				   LONGLONG* lpn64WaveOffset, // offset to data chunk
				   char* lpszErr 
				   );

// win2kapi.cpp
BOOL ExListView(HWND hListWnd);

//-----------------------------------------------------------------
// ^TCYvZ
void GetDataSize(WAVEFORMATEX waveFmt,DWORD dwRecTime, LONGLONG* lpn64Size){

	*lpn64Size = (LONGLONG)dwRecTime * waveFmt.nAvgBytesPerSec;
}



//-------------------------------------------------------------------
// pXt̃t@Ct@C̖O𒊏o֐
LPSTR GetFileName(LPSTR lpszFilePathName)
{
	
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH];
	static CHAR szFileName[MAX_PATH];
	_splitpath(lpszFilePathName,fDrive,fPath,fName,fExt);
	wsprintf(szFileName,"%s%s",fName,fExt);  
	
	return(szFileName);
}


//-------------------------------------------------------------------
// ^Ԃ𕶎ŕԂ֐
void GetRecordingTime(WAVEFORMATEX waveFmt,DWORD dwRecTime, LPSTR lpszTime){

	LONGLONG n64FileSize;
	LONG nH,nM,nS;
	
	GetDataSize(waveFmt,dwRecTime,&n64FileSize);
	
	nH = (LONG)(n64FileSize/waveFmt.nAvgBytesPerSec/60/60);
	nM = (LONG)(n64FileSize/waveFmt.nAvgBytesPerSec/60 - nH*60);
	nS = (LONG)((n64FileSize/waveFmt.nAvgBytesPerSec)%60);
	
	wsprintf(lpszTime,"%3d  %2d  %2d b",nH,nM,nS);
}


//-------------------------------------------------------------------
// Nbv{[hɕRs[
BOOL CopyStringToClip(HWND hWnd,LPSTR lpszStr){

	HGLOBAL hMem;
	LPSTR lpszCopy;

	if(OpenClipboard(hWnd)){

		hMem = GlobalAlloc(GHND,strlen(lpszStr)+16);
		lpszCopy = (LPSTR)GlobalLock(hMem);
		strcpy(lpszCopy,lpszStr);
		GlobalUnlock(hMem);

		EmptyClipboard();
		SetClipboardData(CF_TEXT,hMem);
		CloseClipboard();
	}
	else return FALSE;

	return TRUE;
}




//-------------------------------------------------------------------
// set the command line strings  2003/1/16 
// note: this function is used in both 'waveflt' and 'lockon'
VOID SetCommandStrings(
#ifndef DEF_WAVEFLT
					   BOOL bCommand,
#endif
					   BOOL bFstdin,  // use 'fstdin'
					   LPSTR lpszCommand, // output strings
					   LPSTR lpszCommandIn, // input strings
					   LPSTR lpszFile,     // file name
					   LPSTR lpszUserDef1, // user defined strings 
					   LPSTR lpszUserDef2,
					   LPSTR lpszUserDef3,
					   SYSTEMTIME sysTime, // current time
					   WAVEFORMATEX waveFmt,
					   LONGLONG n64DataSize // data size
#ifndef DEF_WAVEFLT
					   ,HWND hWnd,  // hwnd of lockon
					   DWORD dwRecTime, // recording time(sec) : if n64DataSize = 0, use this parameter
					   BOOL bOpenConsole, // open console
					   WORD wSaveMode // save mode
#endif
					   )
{
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH];
	CHAR fPathM[MAX_PATH],fDriveM[MAX_PATH];
	char szFileSize[CHR_BUF],szDataSize[CHR_BUF];
	int i,i2,i3;
	CHAR szStr[MAX_COM_LNG],lpszStrings[MAX_COM_LNG];
	WORD wTime;
	CHAR* szWeek[7] = {"SUN","MON","TUE","WED","THU","FRI","SAT"};
	DWORD dwHeadSize;
	LONGLONG n64FileSize;

	// get header size
	if(n64DataSize >= 0xFFFFFFFF-44) dwHeadSize = WAVEHDRSIZE(TRUE);
	else dwHeadSize = WAVEHDRSIZE(FALSE);
	
#ifndef DEF_WAVEFLT
	if(strlen(lpszCommandIn) >= MAX_COM_LNG)
	{
		MyMessageBox(hWnd,"R}h܂BZĂ","LOCK ON", MB_OK|MB_ICONERROR);
		lpszCommand[0] = '\0';
		return;
	}
	if(strlen(lpszFile) >= MAX_PATH)
	{
		MyMessageBox(hWnd,"t@C܂BZĂ","LOCK ON", MB_OK|MB_ICONERROR);
		lpszCommand[0] = '\0';
		return;
	}

	// get file size
	if(n64DataSize == 0)
	{
		GetDataSize(waveFmt,dwRecTime,&n64DataSize);
	}

	if(wSaveMode == SAVE_PIPE) 
	{
		dwHeadSize = WAVEHDRSIZE(FALSE);
		if(n64DataSize > 0xFFFFFFFF-dwHeadSize) n64DataSize = 0xFFFFFFFF-dwHeadSize;
	}
#endif

	n64FileSize = n64DataSize + dwHeadSize;

	sprintf(szDataSize,"%I64d",n64DataSize);
	sprintf(szFileSize,"%I64d",n64FileSize);

	// get module path
	GetModuleFileName(NULL,szStr,CHR_BUF);
	_splitpath(szStr,fDriveM,fPathM,NULL,NULL);	
	
#ifndef DEF_WAVEFLT
	if(bCommand && strlen(lpszCommandIn))
#else
	if(strlen(lpszCommandIn))
#endif
	{
		
		// delete spaces
		i=0; while(lpszCommandIn[i] == ' ') i++;
		strcpy(lpszStrings,lpszCommandIn+i);

		// SCMPX or WM8EUTIL or wavedemp or ssrc or wmcmd.vbs
		if(bFstdin){
			if(_strnicmp(lpszStrings,"scmpx",5) == 0
				|| _strnicmp(lpszStrings,"wm8eutil",8) == 0
				|| _strnicmp(lpszStrings,"wavedemp",8) == 0
				|| _strnicmp(lpszStrings,"ssrc",4) == 0
				|| _strnicmp(lpszStrings,"wmcmd.vbs",9) == 0
				)
			{
				strcpy(szStr,lpszStrings);
				strcpy(lpszStrings,"fstdin -dos ");

				// option
				if(_strnicmp(szStr,"wm8eutil",8) ==0)
					strcat(lpszStrings,"-v -dmysize %B ");
				else if(_strnicmp(szStr,"scmpx",5) == 0)
					strcat(lpszStrings,"-v -dmysize %B -hide ");
				else if(_strnicmp(szStr,"wavedemp",8) ==0)
					strcat(lpszStrings,"-adjwave \"%a\" -dmysize %B ");
				else if(_strnicmp(szStr,"wmcmd.vbs",9) ==0)
				{
					strcat(lpszStrings,"-v -dmysize %B ");
#ifndef DEF_WAVEFLT
					if(!bOpenConsole) strcat(lpszStrings,"-hidecon ");
#endif
				}

				// command
				strcat(lpszStrings,"-command \"");

				if(_strnicmp(szStr,"wmcmd.vbs",9) ==0)
				{
					strcat(lpszStrings,"cscript.exe %^");
					strcat(lpszStrings,fDriveM);
					strcat(lpszStrings,fPathM);
				}

				i2 = strlen(lpszStrings);
				i = 0;
				while(szStr[i]!='\0' && i2 < MAX_COM_LNG)
				{
					// stdin -> dummy.dat 
					if(_strnicmp(szStr+i,"stdin",5)==0)
					{
						strcat(lpszStrings,"dummy.dat");
						i+=4; i2+= 8;
					}
					// wmcmd.vbs -> wmcmd.vbs%^ 
					else if(_strnicmp(szStr+i,"wmcmd.vbs",9)==0)
					{
						strcat(lpszStrings,"wmcmd.vbs%^");
						i+=8; i2+= 10;
					}
#ifndef DEF_WAVEFLT  // " -> %^ 
					else if(szStr[i] == '"')
					{
						strcat(lpszStrings,"%^");
						i2++;
					}
#else  
					// %^ -> %%^ , and then %%^ -> %^ below. (waveflt2)
					else if(_strnicmp(szStr+i,"%^",2)==0)
					{
						strcat(lpszStrings,"%%^");
						i++; i2+= 2;
					}
#endif
					else {
						lpszStrings[i2] = szStr[i]; 
					}
					i++;
					i2++;
					lpszStrings[i2] = '\0';
				}
				strcat(lpszStrings,"\"");
			}
			
		}
		//---------------------------------------

		_splitpath(lpszFile,fDrive,fPath,fName,fExt);
		i=0;i2=0;
		
		// replacement
		while(lpszStrings[i]!='\0' && i2 < MAX_COM_LNG)
		{
		 	if(lpszStrings[i]=='%'){
				
				switch(lpszStrings[i+1]){

#ifdef DEF_WAVEFLT  
					// %^ -> "  (waveflt2)
				case '^':

					lpszCommand[i2] = '"';
					i2++;
					i+=2;

					break;
#endif



#ifndef DEF_WAVEFLT  
					// %L -> hwnd (lockon)
				case 'L':

					wsprintf(szStr,"%lu",(DWORD)hWnd);
					i3 = 0;
					while(szStr[i3]!='\0' && i2< MAX_COM_LNG)
					{
						lpszCommand[i2] = szStr[i3];
						i2++;i3++;
					}
					i+=2;

					break;
#endif

					// %
				case '%':
					
					lpszCommand[i2] = '%';
					i2++;
					i+=2;
					
					break;
					
					// drive
				case 'd':
					
					i3 = 0;
					while(fDrive[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = fDrive[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;
					
					// path
				case 'p':
					
					i3 = 0;
					while(fPath[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = fPath[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;
					
					
					// file
				case 'f':
					
					i3 = 0;
					while(fName[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = fName[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;
					
					// ext
				case 'e':
					
					i3 = 0;
					while(fExt[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = fExt[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;
					
					// file name
				case 'a':
					
					i3 = 0;
					while(lpszFile[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = lpszFile[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

				// data size
				case 'b':
					
					i3 = 0;
					while(szDataSize[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = szDataSize[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

				// file size(header size + data size)
				case 'B':
					
					i3 = 0;
					while(szFileSize[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = szFileSize[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

				// user defined strings 1
				case '1':
					
					i3 = 0;
					while(lpszUserDef1[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = lpszUserDef1[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

					// user defined strings 2
				case '2':
					
					i3 = 0;
					while(lpszUserDef2[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = lpszUserDef2[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

				// user defined strings 3
				case '3':
					
					i3 = 0;
					while(lpszUserDef3[i3]!='\0' && i2 < MAX_COM_LNG)
					{
						lpszCommand[i2] = lpszUserDef3[i3];
						i2++;i3++;
					}
					i+=2;
					
					break;

					
					// year, month, day, 
				case 'Y':  
					
					wsprintf(szStr,"%04d",sysTime.wYear);
					for(i3=0;i3<2;i3++,i2++) lpszCommand[i2] = szStr[i3+2];
					i+=2;
					
					break;
					
				case 'M': wTime = sysTime.wMonth;goto L_TIMESET;
				case 'D': wTime = sysTime.wDay;	goto L_TIMESET;
				case 'H': wTime = sysTime.wHour; goto L_TIMESET;
				case 'N': wTime = sysTime.wMinute; goto L_TIMESET;
				case 'S': wTime = sysTime.wSecond; goto L_TIMESET;
L_TIMESET:
					wsprintf(szStr,"%02d",wTime);  
					for(i3=0;i3<2;i3++,i2++) lpszCommand[i2] = szStr[i3];
					i+=2;
					break;

				case 'W': // szWeek[7] = {"SUN","MON","TUE","WED","THU","FRI","SAT"};
					for(i3=0;i3<3;i3++,i2++) 
						lpszCommand[i2] = szWeek[sysTime.wDayOfWeek][i3];
					i+=2;
					
					break;

					/*
#ifdef DEF_WAVEFLT // Jn

				case 's':

					switch(lpszStrings[i+2]){
						
						// N
					case 'Y':  // 2002 N̏ꍇ͉񌅂 02 Ԃ
						
						wsprintf(szStr,"%04d",splitTime.wYear);
						for(i3=0;i3<2;i3++,i2++) lpszCommand[i2] = szStr[i3+2];
						i+=3;
						
						break;
						
					case 'M': wTime = splitTime.wMonth;goto L_STIMESET;
					case 'D': wTime = splitTime.wDay;	goto L_STIMESET;
					case 'H': wTime = splitTime.wHour; goto L_STIMESET;
					case 'N': wTime = splitTime.wMinute; goto L_STIMESET;
					case 'S': wTime = splitTime.wSecond; goto L_STIMESET;
L_STIMESET:
						wsprintf(szStr,"%02d",wTime);  
						for(i3=0;i3<2;i3++,i2++) lpszCommand[i2] = szStr[i3];
						i+=3;
						break;
						
					case 'W': // T szWeek[7] = {"SUN","MON","TUE","WED","THU","FRI","SAT"};
						for(i3=0;i3<3;i3++,i2++) 
							lpszCommand[i2] = szWeek[splitTime.wDayOfWeek][i3];
						i+=3;
						
						break;
						
					default:
						lpszCommand[i2] = lpszStrings[i];
						lpszCommand[i2+1] = lpszStrings[i+1];
						i+=2;i2+=2;
					}
#endif
*/
					
				default:
					lpszCommand[i2] = lpszStrings[i];
					i++;i2++;
				}
			}
			else {
				lpszCommand[i2] = lpszStrings[i];
				i++;i2++;
			}
		}
		
		lpszCommand[i2] = '\0';
        }
        else wsprintf(lpszCommand,"");
}






//-------------------------------------------------------------------
// `F[^ CD ^̎Ƀt@CZbg֐
VOID SetChainFileName(LPSTR lpszFile,LPSTR lpszChainFile,WORD wChainNum){
	
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH];
	
	_splitpath(lpszFile,fDrive,fPath,fName,fExt);
	wsprintf(lpszChainFile,"%s%s%s-%03d%s",fDrive,fPath,fName,wChainNum,fExt);  
	
}




//-----------------------------------
// R}hC̕擾֐(WAVEFLT Ƌ) 2000/2/19 
// ߂l = argc
int GetArgv(char* lpszCmdLine,char argv[MAX_ARGC][CHR_BUF],int start_pos){
	
	int cmdln;
	int i,i2,argc;
	char c;
	
	cmdln = strlen(lpszCmdLine);
	for(i=0;i<MAX_ARGC;i++) argv[i][0] = '\0';

	argc = start_pos;
	if(cmdln > 0){

		i = 0;
		while(i < cmdln && argc < MAX_ARGC){

			// 󔒂Ɖs΂
			while(lpszCmdLine[i] == ' ' 
				|| lpszCmdLine[i] == '\n' || lpszCmdLine[i] == '\r') i++;

			if(i>=cmdln) break;

			// "" ň͂܂Ăꍇ
			if(lpszCmdLine[i] == '"') {
				c = '"'; 
				i++;
			}
			else c = ' ';

			// Rs[
			i2 = 0;
			while(lpszCmdLine[i] != '\0' && lpszCmdLine[i] != c){
				argv[argc][i2] = lpszCmdLine[i];
				i++;i2++;
			}

			if(c ==  '"') i++;
			
			argv[argc][i2] = '\0';
			argc++;i++;
		}
	}

	return argc;
}




//-----------------------------------------------------------------
// ENbNj[
UINT ClickRButton(HWND hWnd,LPPRERECFILE lpPre,LPPRERECFOLDER lpPreFold){
	
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	HMENU hPopMenu,hSubMenu,hSubMenu2;
	MENUITEMINFO menuItem;
	POINT point;
	UINT uID = 0;
	int i;
	CHAR szStr[CHR_BUF];

	hPopMenu = CreatePopupMenu();
	hSubMenu = CreateMenu();
	hSubMenu2 = CreateMenu();
	
	if(hPopMenu != NULL && hSubMenu != NULL && hSubMenu2 != NULL){
		
		// t@Cj[쐬
		i = lpPre->wFirst;
		while(i != lpPre->wCurrent)
		{
			if(lpPre->wChain[i] > 0) wsprintf(szStr,"%s [C]",lpPre->szChainFile[i]);
			else strcpy(szStr,lpPre->szChainFile[i]);
			InsertMenu(hSubMenu,0,MF_BYPOSITION,i+1,szStr);
			i = (i+1) % PRERECFILENUM;
		}

		// tH_j[쐬
		i = lpPreFold->wFirst;
		while(i != lpPreFold->wCurrent)
		{
			_splitpath(lpPreFold->szFolder[i],fDrive,fPath,fName,fExt);	
			wsprintf(szStr,"%s%s",fDrive,fPath); 
			InsertMenu(hSubMenu2,0,MF_BYPOSITION,PRERECFILENUM+i+1,szStr);
			i = (i+1) % PRERECFILENUM;
		}

		// fobO[h
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+6;   
		menuItem.dwTypeData = "fobO[hؑ";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);

		// wv
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+5;   
		menuItem.dwTypeData = "wv\";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);

		// o[W\
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+4;   
		menuItem.dwTypeData = "o[W";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);

		// ݒۑ
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+3;   
		menuItem.dwTypeData = "ݒ̕ۑ";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);

		//Zp[^
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_TYPE;
		menuItem.fType = MFT_SEPARATOR;
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);

		// bNĨtH_J
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+8;   // ID  PRERECFILENUM*2 + 8
		menuItem.dwTypeData = "bÑtH_J";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);


		// ݂̃tH_J
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+1;   // ID  PRERECFILENUM*2 + 1
		menuItem.dwTypeData = "݂̃tH_J";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);


		// tH_j[}
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_SUBMENU|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.hSubMenu = hSubMenu2;
		menuItem.dwTypeData = "ŋߎgtH_";

		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);


		// t@Cj[}
		menuItem.hSubMenu = hSubMenu;
		menuItem.dwTypeData = "ŋߘ^t@C";

		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);


		// vpeB
		ZeroMemory(&menuItem,sizeof(MENUITEMINFO));
		menuItem.cbSize = sizeof(MENUITEMINFO);
		menuItem.fMask = MIIM_ID|MIIM_TYPE;
		menuItem.fType = MFT_STRING;
		menuItem.wID = PRERECFILENUM*2+2;   // ID  PRERECFILENUM*2 + 2
		menuItem.dwTypeData = "^ݒ\";
		InsertMenuItem(hPopMenu,0,TRUE,&menuItem);
		

		GetCursorPos(&point);
		uID = TrackPopupMenu(hPopMenu, TPM_LEFTALIGN|TPM_RETURNCMD,
			point.x, point.y, 0, hWnd, NULL);
		
	}

	if(hPopMenu != NULL) DestroyMenu(hPopMenu);
	if(hSubMenu != NULL) DestroyMenu(hSubMenu);
	if(hSubMenu2 != NULL) DestroyMenu(hSubMenu2);
	
	return uID;
}




//------------------------------------------
// R\[ HWND Qbg֐
HWND GetConsoleWindowHandle()
{
	char szOldTitle[CHR_BUF],szNewTitle[CHR_BUF];
	HWND hWnd = NULL;
	
	GetConsoleTitle(szOldTitle,CHR_BUF);
    wsprintf(szNewTitle,"console(%d-%d)",GetCurrentProcessId(),GetTickCount());
	SetConsoleTitle(szNewTitle);
	Sleep(40);
	hWnd = FindWindow(NULL, szNewTitle);
	SetConsoleTitle(szOldTitle);
	
	return(hWnd);
}




//-------------------------------------
// ^ݒ\_CAÕvV[W
LRESULT PropShowProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{

	switch (msg) {
		
	case WM_INITDIALOG:  // _CAO
		
		// _CAOړ
		SetDlgCenter(hWnd);

		// L[{[htH[JXZbg
		// DialogBoxParam ŌĂ񂾏ꍇAȂ
		// L[{[hőłȂȂ
		SetFocus(GetDlgItem(hWnd,IDOK));

		Edit_SetText(GetDlgItem(hWnd,IDC_EDITRES),(LPSTR)lp);

		break;
		
	case WM_COMMAND:
		
		switch (LOWORD(wp)) {
			
		case IDOK:  // ^
			
			EndDialog(hWnd, IDOK);
			
			return TRUE;

		case IDYES:  // Rs[
			
			EndDialog(hWnd, IDYES);
			
			return TRUE;

		case IDNO: // ZbgAbv
			
			EndDialog(hWnd, IDNO);
			
			return TRUE;

		case IDCANCEL: // LZ
			
			EndDialog(hWnd, IDCANCEL);
			
			return TRUE;	
			
		}
		break;
		
		default:
			break;
	}
    return FALSE;
}



//-------------------------------------
// ^vpeB\
int ShowProperty(HWND hWnd,
				 LPSTR szRecFile,
				 LPLOCKONDATA lpLod,
				  LPPIPEEXECOMDATA lpComData
				  )
{
	WORD wSaveMode;
	HINSTANCE hInst;
	char szStr[8192]; // Ƃ肠 8k 炢c
	char szTemp[MAX_COM_LNG];
	CHAR szCommand[MAX_COM_LNG]; // ^IɃR}hCɓn
	CHAR szPipeCommand[MAX_COM_LNG]; // pCv^ɋNR}h
	DWORD dwFileMaxSize;
	SYSTEMTIME sysTime;
	int nRet;
	LONGLONG n64FileSize;
	
	szStr[0] = '\0';

	GetLocalTime(&sysTime);
	
	// TCYAZ[u[hA
	GetDataSize(lpLod->waveFmt,lpLod->dwRecTime,&n64FileSize);
	dwFileMaxSize = (DWORD)(n64FileSize/1024/1024);
	wSaveMode = lpLod->wSaveMode;

	GetRecordingTime(lpLod->waveFmt,lpLod->dwRecTime,szTemp);
	
	wsprintf(szStr,"%s\r\n     [%s %dM] %s",
		szStr,
		"HDD\0MEM\0PIPE"+wSaveMode*4,
		dwFileMaxSize,szTemp);
	
	// tH[}bg
	wsprintf(szStr,"%s %5dHz %2dBit %s",
		szStr,
		lpLod->waveFmt.nSamplesPerSec,
		lpLod->waveFmt.wBitsPerSample,
		"mono\0stereo"+(lpLod->waveFmt.nChannels-1)*5);
	
	if(lpLod->wForceMono == FORCE_MONO_LEFT)
		wsprintf(szStr,"%s [mE]",szStr);
	else if(lpLod->wForceMono == FORCE_MONO_RIGHT)
		wsprintf(szStr,"%s [mEE]",szStr);
	
	// t@C
	wsprintf(szStr,"%s\r\n     [FILE:uO] %s",szStr,szRecFile);
	SetCommandStrings(TRUE,TRUE,
			szTemp,
			szRecFile,
			szRecFile,
			lpLod->szCom1,lpLod->szCom2,lpLod->szCom3,sysTime,
			lpLod->waveFmt,0,hWnd,lpLod->dwRecTime,lpLod->bOpenConsole,wSaveMode);
	wsprintf(szStr,"%s\r\n     [FILE:u] %s",szStr,szTemp);
	

	// %1 %2 %3
	wsprintf(szStr,"%s\r\n     [%%1] %s\r\n     [%%2] %s\r\n     [%%3] %s",
		szStr,
		lpLod->szCom1,
		lpLod->szCom2,
		lpLod->szCom3);
	
	// pCv
	if(wSaveMode == SAVE_PIPE)
	{
		wsprintf(szStr,"%s\r\n     [PIPE:uO] %s",szStr
			,lpComData->szPipeCommandLine[lpLod->wPipeCommandNum]);
		
		SetCommandStrings(TRUE,TRUE,
			szTemp,
			szRecFile,
			szRecFile,
			lpLod->szCom1,lpLod->szCom2,lpLod->szCom3,sysTime,
			lpLod->waveFmt,0,hWnd,lpLod->dwRecTime,lpLod->bOpenConsole,wSaveMode);
		SetCommandStrings(TRUE,TRUE,
			szPipeCommand,
			lpComData->szPipeCommandLine[lpLod->wPipeCommandNum],
			szTemp,
			lpLod->szCom1,lpLod->szCom2,lpLod->szCom3,sysTime,
			lpLod->waveFmt,0,hWnd,lpLod->dwRecTime,lpLod->bOpenConsole,wSaveMode);
		
		wsprintf(szStr,"%s\r\n     [PIPE:u] %s",szStr,szPipeCommand);
		
	}
	
	// ^R}h
	if(lpLod->bCommandLine)
	{
		wsprintf(szStr,"%s\r\n     [^R}h:uO] %s",szStr
			,lpComData->szCommandLine[lpLod->wCommandNum]);
		
		SetCommandStrings(TRUE,FALSE,
			szTemp,
			szRecFile,
			szRecFile,
			lpLod->szCom1,lpLod->szCom2,lpLod->szCom3,sysTime,
			lpLod->waveFmt,0,hWnd,lpLod->dwRecTime,lpLod->bOpenConsole,wSaveMode);
		SetCommandStrings(TRUE,FALSE,
			szCommand,
			lpComData->szCommandLine[lpLod->wCommandNum],
			szTemp,
			lpLod->szCom1,lpLod->szCom2,lpLod->szCom3,sysTime,
			lpLod->waveFmt,0,hWnd,lpLod->dwRecTime,lpLod->bOpenConsole,wSaveMode);
		
		wsprintf(szStr,"%s\r\n     [^R}h:u] %s",szStr
			,szCommand);
	}
	
	if(lpLod->bChainRec){
		wsprintf(szStr,"%s\r\n     [`F[^s]",szStr);
	}
	

	if(IsReadyMP3() || IsReadyOGG(szTemp))
	{
		wsprintf(szStr,"%s\r\n\r\n",szStr);

		if(IsReadyMP3()) wsprintf(szStr,"%s\r\n     [MP3 Đ\] vbmp3.dll [hς",szStr);
		if(IsReadyOGG(szTemp)){
			wsprintf(szStr,"%s\r\n     [OGG Đ\] %s",szStr,szTemp);
		}
	}

	// fobOp
	if(CheckThreadMoving())
		wsprintf(szStr,"%s\r\n     ^Xbh쒆",szStr);
	if(CheckCoreMoving())
		wsprintf(szStr,"%s\r\n     RA쒆",szStr);
	
	hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	nRet = DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_PROPERTY),hWnd,
		(DLGPROC)PropShowProc,(LPARAM)szStr);

	if(nRet == IDYES)
	{
		CopyStringToClip(hWnd,szStr);
		nRet = IDCANCEL;
	}

	return nRet;
}




//-------------------------------------
// Xbh\_CAÕvV[W
LRESULT ThreadInfoProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	
	RECTHREADDATA thData;
	SYSTEMTIME sysTime;
	LPSTR lpszWeek[7]={"","","","","","","y"};
	DWORD dwTime,dwRecTime,i;
	char szStr[CHR_BUF];
	LV_COLUMN lv_Col;
	LV_ITEM lv_Item;
	static HWND	hListVWnd;
	static UINT uTimer;
	BOOL bFoo;

	switch (msg) {
		
	case WM_INITDIALOG:  // _CAO
		
		// _CAOړ
		SetDlgCenter(hWnd);

		// L[{[htH[JXZbg
		// DialogBoxParam ŌĂ񂾏ꍇAȂ
		// L[{[hőłȂȂ
		SetFocus(GetDlgItem(hWnd,IDOK));

		// Xgr[g
		hListVWnd = GetDlgItem(hWnd,IDC_LISTTHINFO);
		ExListView(hListVWnd);

		// Xgr[Zbg
		memset(&lv_Col,0,sizeof(LV_COLUMN));
		lv_Col.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
		lv_Col.fmt = LVCFMT_LEFT;

		lv_Col.cx = 70;
		lv_Col.pszText = "Xbh";
		lv_Col.iSubItem = 0;
		ListView_InsertColumn(hListVWnd, 0, &lv_Col);

		lv_Col.cx = 70;
		lv_Col.pszText = "Jn";
		lv_Col.iSubItem = 1;
		ListView_InsertColumn(hListVWnd, 1, &lv_Col);

		lv_Col.cx = 70;
		lv_Col.pszText = "^";
		lv_Col.iSubItem = 2;
		ListView_InsertColumn(hListVWnd, 2, &lv_Col);

		lv_Col.cx = 70;
		lv_Col.pszText = "oߎ";
		lv_Col.iSubItem = 3;
		ListView_InsertColumn(hListVWnd, 3, &lv_Col);

		lv_Col.cx = 100;
		lv_Col.pszText = "t@C";
		lv_Col.iSubItem = 4;
		ListView_InsertColumn(hListVWnd, 4, &lv_Col);

		lv_Col.cx = 300;
		lv_Col.pszText = "t@C(tpX)";
		lv_Col.iSubItem = 5;
		ListView_InsertColumn(hListVWnd, 5, &lv_Col);

	case WM_TIMER: 

		// ACeZbg
		memset(&lv_Item,0,sizeof(LV_ITEM));
		lv_Item.mask = LVIF_TEXT;
		for(i=0;i<MAX_RECTHREAD;i++)
		{
			wsprintf(szStr,"%d",i+1);
            lv_Item.pszText = szStr;
            lv_Item.iItem = i;
            lv_Item.iSubItem = 0;
			if(msg == WM_INITDIALOG)
				ListView_InsertItem(hListVWnd, &lv_Item);
			else
				ListView_SetItem(hListVWnd, &lv_Item);

			if(GetThreadInfo(&thData,i))
			{
				sysTime = thData.sysTimeStart;
				dwTime = thData.dwTime;
				dwRecTime = thData.dwRecTime;
				bFoo = TRUE;
			}
			else bFoo = FALSE;
			
			if(bFoo)
				wsprintf(szStr,"%s %02d:%02d:%02d",
				lpszWeek[sysTime.wDayOfWeek],
				sysTime.wHour,
				sysTime.wMinute,
				sysTime.wSecond);
			else szStr[0] = '\0';
			lv_Item.pszText = szStr;
			lv_Item.iItem = i;
			lv_Item.iSubItem = 1;
			ListView_SetItem(hListVWnd, &lv_Item);
			
			if(bFoo)
				wsprintf(szStr,"%d:%02d:%02d",
				dwRecTime/60/60,
				(dwRecTime/60)%60,
				(dwRecTime)%60
				);
			else szStr[0] = '\0';
			lv_Item.pszText = szStr;
			lv_Item.iItem = i;
			lv_Item.iSubItem = 2;
			ListView_SetItem(hListVWnd, &lv_Item);
			
			if(bFoo)
				wsprintf(szStr,"%d:%02d:%02d",
				dwTime/1000/60/60,
				(dwTime/1000/60)%60,
				(dwTime/1000)%60
				);
			else szStr[0] = '\0';
			lv_Item.pszText = szStr;
			lv_Item.iItem = i;
			lv_Item.iSubItem = 3;
			ListView_SetItem(hListVWnd, &lv_Item);

			if(bFoo)
			{
				strcpy(lv_Item.pszText,GetFileName(thData.szFileName));
			}
			else lv_Item.pszText = "";
			lv_Item.iItem = i;
			lv_Item.iSubItem = 4;
			ListView_SetItem(hListVWnd, &lv_Item);

			if(bFoo)lv_Item.pszText = thData.szFileName;
			else lv_Item.pszText = "";
			lv_Item.iItem = i;
			lv_Item.iSubItem = 5;
			ListView_SetItem(hListVWnd, &lv_Item);

		}

		if(msg == WM_INITDIALOG)
			uTimer = SetTimer(hWnd,1,1000,NULL); 

		break;

		// XgNbN̏
	case WM_NOTIFY:
		
		if ((int)wp == IDC_LISTTHINFO) 
		{
			switch (((LPNMHDR)lp)->code) 
			{
			case NM_CLICK:
				LVHITTESTINFO lvHitTest;
				short pos[2];
				POINT point;
				
				*((LPDWORD)pos) = GetMessagePos();
				point.x = pos[0];
				point.y = pos[1];
				ScreenToClient(hListVWnd,&point);
				lvHitTest.pt = point;
				i = ListView_HitTest(hListVWnd,&lvHitTest);
				if(i != -1)
				{
					wsprintf(szStr,"Xbh %d ~܂?",i+1);
					if(MyMessageBox(hWnd,szStr,"LOCK ON",
						MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2) == IDYES)
						StopRecWave(hWnd,0,i);
				}
			}
			break;
		}
		break;
		
	case WM_COMMAND:

		switch (LOWORD(wp))
		{
			
		case IDOK:  

			KillTimer(hWnd, uTimer);
			EndDialog(hWnd, IDOK);
			
			return TRUE;

		case IDCANCEL: // LZ
			
			KillTimer(hWnd, uTimer);
			EndDialog(hWnd, IDCANCEL);
			
			return TRUE;	
			
		}
		break;
		
		default:
			break;
	}
    return FALSE;
}


//-------------------------------------
// Xbh\_CAO
int ShowThreadInfo(HWND hWnd){

	HINSTANCE hInst;

	hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	return(DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_THREADINFO),hWnd,
		(DLGPROC)ThreadInfoProc,(LPARAM)0));
}





//-------------------------------------------------------------------
// t@CăpX݂Ă邩ׂ֐
// fBNgȂ݂Ȃ FALSE
BOOL ExistDirectory(LPSTR lpszFileName){
	
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	CHAR szFind[MAX_PATH];
	DWORD dwResult;
	
	_splitpath(lpszFileName,fDrive,fPath,fName,fExt);	
	wsprintf(szFind,"%s%s",fDrive,fPath); 
	dwResult = GetFileAttributes(szFind);
	
	if(dwResult & FILE_ATTRIBUTE_DIRECTORY == 0
		||dwResult == 0xFFFFFFFF ) return FALSE;
	
	return TRUE;
}



//-------------------------------------------------------------------
// t@CăfBNg쐬֐
BOOL CreateFileDirectory(LPSTR lpszFileName){
	
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	CHAR szPath[MAX_PATH];
	
	_splitpath(lpszFileName,fDrive,fPath,fName,fExt);	
	wsprintf(szPath,"%s%s",fDrive,fPath); 

	return(CreateDirectory(szPath,NULL));
}



//-------------------------------------------------------------------
// 󂫃擾֐
DWORD GetFreeMemSpace(LPDWORD lpdwTotal){
	
	MEMORYSTATUS memStat;
	GlobalMemoryStatus(&memStat);
	
	if(lpdwTotal != NULL) *lpdwTotal = memStat.dwTotalPhys;
	return(memStat.dwAvailPhys);
}


//-------------------------------------------------------------------
// n[hfBXN̋󂫎擾֐(FAT32,NTFS Ή 64 bit )

typedef BOOL (WINAPI *PGETDISKEX)(LPCTSTR,PULARGE_INTEGER,PULARGE_INTEGER,PULARGE_INTEGER);

VOID GetFreeHddSpace64(ULONGLONG* lpullSize,LPSTR lpszFileName){
	
	CHAR fDrive[CHR_BUF],str[CHR_BUF];
	DWORD sectorClus,byteSect,freeClus,totalClus;
	DWORD dwType;
	HMODULE hModKer32;
	PGETDISKEX pGetDiskEx = NULL;
	ULARGE_INTEGER uliFreeByteAvailCaller;
	ULARGE_INTEGER uliTotalByte;
	
	// kernel32.dll ̃nh擾
	hModKer32 = GetModuleHandle("kernel32.dll");
	
	// GetDiskFreeSpaceEx ̏ꏊT
	if(hModKer32 != NULL){
		pGetDiskEx = (PGETDISKEX)GetProcAddress(hModKer32,"GetDiskFreeSpaceExA");
	}
	
	_splitpath(lpszFileName,str,NULL,NULL,NULL);
	wsprintf(fDrive,"%s\\",str);
	
	dwType = GetDriveType(fDrive);
	
	
	//n[hfBXN݂邩`FbNBTCY 0 ɃZbg
	if(dwType == DRIVE_NO_ROOT_DIR || dwType == DRIVE_UNKNOWN) uliFreeByteAvailCaller.QuadPart = 0;
	else {
		// o[W Windows
		if(pGetDiskEx == NULL){
			GetDiskFreeSpace(fDrive,&sectorClus,&byteSect,&freeClus,&totalClus);
			uliFreeByteAvailCaller.QuadPart = sectorClus*byteSect*freeClus;
		}
		else // Vo[W(FAT32,NTFS Ή) 
			(*pGetDiskEx)(fDrive,&uliFreeByteAvailCaller,&uliTotalByte,NULL);
	}
	
	*lpullSize = uliFreeByteAvailCaller.QuadPart;
}



//-------------------------------------------------------------------
// _CAO𒆐SɈړ֐
VOID SetDlgCenterEx(HWND hWnd,BOOL bTop)
{
	RECT parentRt, deskRt,rt;
	HWND hParentWnd,hDeskWnd; 
	LONG x, y;

	// gbvEBhẼnh擾
	hDeskWnd = GetDesktopWindow();
	
	if(!bTop)
	{
		// ẽnh擾
		hParentWnd = GetParent(hWnd);
		
		// egbvEBhȄꍇ
		if(hParentWnd == NULL) hParentWnd = hDeskWnd;
	}
	else hParentWnd = hDeskWnd;
	
	// _CAO𒆐SɈړ
	GetWindowRect(hParentWnd, &parentRt);
	GetWindowRect(hWnd, &rt);
	x = parentRt.left+((parentRt.right-parentRt.left) - (rt.right-rt.left)) / 2;
	y = parentRt.top+((parentRt.bottom-parentRt.top) - (rt.bottom-rt.top)) / 2;
	
	// ʂ͂ݏoȂ`FbN
	GetWindowRect(hDeskWnd, &deskRt);
	x = max(0,min(x,deskRt.right-(rt.right-rt.left)));
	y = max(0,min(y,deskRt.bottom-(rt.bottom-rt.top)));
	
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOREPOSITION|SWP_NOZORDER);
}

VOID SetDlgCenter(HWND hWnd){SetDlgCenterEx(hWnd,FALSE);}



//-------------------------------------------------------------------
// 2 t@C̃tH_`FbN֐
BOOL CheckSameFolder(LPSTR lpszFile1,LPSTR lpszFile2){
	
	CHAR fPath1[MAX_PATH],fDrive1[MAX_PATH],fName1[MAX_PATH],fExt1[MAX_PATH];
	CHAR fPath2[MAX_PATH],fDrive2[MAX_PATH],fName2[MAX_PATH],fExt2[MAX_PATH];
	CHAR szPath1[MAX_PATH],szPath2[MAX_PATH];

	_splitpath(lpszFile1,fDrive1,fPath1,fName1,fExt1);
	_splitpath(lpszFile2,fDrive2,fPath2,fName2,fExt2);
	wsprintf(szPath1,"%s%s",fDrive1,fPath1);  
	wsprintf(szPath2,"%s%s",fDrive2,fPath2);  

	if(_strnicmp(szPath1,szPath2,MAX_PATH) != 0) return FALSE;

	return TRUE;
}


//-------------------------------------
// V[gt@COt@C֕ϊ֐
BOOL ShortToLongName(LPSTR lpszFileName){
	
	char fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	WIN32_FIND_DATA findData;
	HANDLE hFind;

	hFind = FindFirstFile(lpszFileName,&findData);
	
	if(hFind==INVALID_HANDLE_VALUE) return FALSE;
	
	FindClose(hFind); 
	
	_splitpath(lpszFileName,fDrive,fPath,fName, fExt);	
	wsprintf(lpszFileName,"%s%s%s",fDrive,fPath,findData.cFileName);  
	
	return TRUE;
}



//-------------------------------------
// pXw肳ĂȂJg̃pXݒ肷֐
VOID SetFileToCurrentDir(LPSTR lpszFileName){
	
	char fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 

	_splitpath(lpszFileName,fDrive,fPath,fName, fExt);	
	if(!strlen(fDrive) || !strlen(fPath)){
		GetCurrentDirectory(MAX_PATH,fPath);
		wsprintf(lpszFileName,"%s\\%s%s",fPath,fName,fExt);  
	}
}



//--------------------------------------------------
// XN[o[֐
VOID SetMyScrollBar(HWND hScrWnd,LPSCROLLINFO lpScrInfo,BOOL bSet){
	
	lpScrInfo->nPos = 0;
	lpScrInfo->nMax = MAX_SBPOS;
	EnableWindow(hScrWnd,bSet);
	SetScrollInfo(hScrWnd,SB_CTL,lpScrInfo,bSet);
	
}







//-------------------------------------------------------------------
// Đt@CZbg̏
WORD SetPlayWaveFile(HWND hWnd,HWND hScrWnd,
					 HDC hBufDC,HDC hBufDC2,
					 LPSTR lpszFileName,
					 LPSCROLLINFO lpScrInfo,
					 LPWAVEFORMATEX lpPlayWaveFmt,
					 WAVEFORMATEX recWaveFmt,
					 WORD wForceMono,
					 WORD wSaveMode,
					 LPDWORD lpdwWaveTime,
					 LONGLONG* lpn64FileSize,
					 DWORD dwRecTime,
					 BOOL bStayOnTop,BOOL bTimeView,
					 BOOL bUseBgBitmap,BOOL bShowPath,
					 BOOL bChain,
					 BOOL bReset,
					 COLORREF fontColor)
{
	
	CHAR szStr[CHR_BUF];
	WORD wRet = PLAYFILE_NOT;
	static BOOL bPreShowScrBar = FALSE;
	DWORD dwCurTime;

	LONGLONG n64WaveDataSize;
	LONGLONG n64WaveOffset;
	DWORD dwFileSize;
	
	// ^Xe[^X\
	SetRecStatus(hWnd,hBufDC,hBufDC2,recWaveFmt,wForceMono,dwRecTime,
		bStayOnTop,wSaveMode,bTimeView,
		bChain,fontColor);
	
	// Đt@C擾
	
	// Wave t@C
	if(GetWaveFormat(lpszFileName,lpPlayWaveFmt,&n64WaveDataSize,&n64WaveOffset,szStr))
	{
		*lpdwWaveTime = (DWORD)(n64WaveDataSize/lpPlayWaveFmt->nAvgBytesPerSec*1000);
		*lpn64FileSize = n64WaveOffset + n64WaveDataSize;
		wRet = PLAYFILE_WAVE;
	}
	// OGG 
	else if(GetFormatOGG(hWnd,lpszFileName,lpPlayWaveFmt,lpdwWaveTime,&dwFileSize))
	{
		*lpn64FileSize = dwFileSize;
		wRet = PLAYFILE_OGG;
	}
	// MP3 
	else if(GetFormatMP3(hWnd,lpszFileName,lpPlayWaveFmt,lpdwWaveTime,&dwFileSize))
	{
		*lpn64FileSize = dwFileSize;
		wRet = PLAYFILE_MP3;
	}
	// t@C݂͑邩
	else if(GetFileAttributes(lpszFileName) != 0xFFFFFFFF) wRet = PLAYFILE_UKN;
	
	if(wRet == PLAYFILE_MP3 || wRet == PLAYFILE_OGG || wRet == PLAYFILE_WAVE)
	{
		// XN[o[
		if(bReset) SetMyScrollBar(hScrWnd,lpScrInfo,TRUE);
	
		dwCurTime = (DWORD)((double)lpScrInfo->nPos/MAX_SBPOS*(*lpdwWaveTime)); 
			
		// t@CXe[^X\
		SetPlayFileInfo(hWnd,hBufDC,wRet,*lpPlayWaveFmt,
			*lpn64FileSize,*lpdwWaveTime,dwCurTime,bTimeView,
			hBufDC2,fontColor);
	}
	else
	{
		if(wRet == PLAYFILE_UKN) ShowStatus(hWnd,hBufDC,"[Unknown Format]",hBufDC2,fontColor);
		else ShowStatus(hWnd,hBufDC,"[Ready]",hBufDC2,fontColor);
		
		// XN[o[
		SetMyScrollBar(hScrWnd,lpScrInfo,FALSE);
	}
	
	//^CgZbg
	if(!bShowPath) wsprintf(szStr,"LOCK ON [ - ] %s",GetFileName(lpszFileName));
	else wsprintf(szStr,"LOCK ON [ - ] %s",lpszFileName);
	SetTitle(hWnd,hBufDC,hBufDC2,(LPSTR)szStr,bUseBgBitmap,(GetActiveWindow()==hWnd));
	
	return wRet;
}



//-------------------------------------------------------------------
// wv\
VOID ShowHelp(HWND hWnd){
	
	CHAR path[MAX_PATH],driveName[MAX_PATH],pathName[MAX_PATH],str[MAX_PATH];
	
	// wvt@C̃pX擾
	GetModuleFileName(NULL,str,CHR_BUF);
	_splitpath(str,driveName,pathName,NULL, NULL);	
	wsprintf(path,"%s%s",driveName,pathName);
	wsprintf(str,"%s%s",path,"help.htm");
	
	if((WORD)ShellExecute(hWnd,NULL,str,NULL,path,SW_SHOWNORMAL) == ERROR_FILE_NOT_FOUND ){
		MyMessageBox(hWnd,"wvt@C(help.htm)܂łB","Error",MB_OK|MB_ICONERROR);
	}
	
	// Ăяo
	
}



//-------------------------------------------------------------------
// XN[o[Zbg
LONG SetScrBarInfo(HWND hScrWnd,LPSCROLLINFO lpScrInfo,WPARAM wp){
	
	// ݈ʒuZbg
	SCROLLINFO curScrInfo;
	LONG nMove = (lpScrInfo->nMax - lpScrInfo->nMin)/50;
	LONG nPos = lpScrInfo->nPos;
	
	switch (LOWORD(wp)) {
		
	case SB_LINEUP:   
		nPos -= 1;	
		break;
		
	case SB_LINEDOWN:	
		nPos += 1;	   
		break;
		
	case SB_PAGEUP:   
		nPos -= nMove;
		break;
		
	case SB_PAGEDOWN: 
		nPos += nMove;
		break;
		
	case SB_THUMBPOSITION:	 
	case SB_THUMBTRACK: 
		curScrInfo.cbSize = sizeof(SCROLLINFO);
		curScrInfo.fMask = SIF_TRACKPOS;
		GetScrollInfo(hScrWnd,SB_CTL,&curScrInfo);
		nPos = curScrInfo.nTrackPos;	
		break;
		
	}
	
	lpScrInfo->nPos = max(lpScrInfo->nMin,min(nPos,lpScrInfo->nMax));
	SetScrollInfo(hScrWnd,SB_CTL,lpScrInfo,TRUE);
	
	return(lpScrInfo->nPos);
}



//-------------------------------------------------------------------
// double -> CHAR ϊ֐  2002/5/31
LPCSTR myfcvt(double val,
			  long n,    // Ŝ̌(܂)
			  long count // _ȉ̌
			  ){
	
	static char szOutStr[CHR_BUF];
	char szStr[CHR_BUF];
	char* lpszStr;
	int dec,sign,ii;
	
	lpszStr = _fcvt(val,count,&dec,&sign);
	
	if(dec>CHR_BUF){
		wsprintf(szOutStr,"0");
	}
	else
	{
		
		// Rs[
		ii=0;
		if(dec>0){
			for(ii=0;ii < dec;ii++) szStr[ii] = lpszStr[ii];
		}
		else {
			wsprintf(szStr,"0");
			ii++;
		}
		
		szStr[ii++] = '.';
		
		// 0 }
		while(dec < 0 && count > 0) {szStr[ii++] = '0'; dec++; count--;};
		
		// Rs[
		wsprintf(szStr+ii,"%s",lpszStr+dec);
		
		//
		if(sign) wsprintf(szOutStr,"-%s",szStr);
		else wsprintf(szOutStr,"%s",szStr);
		
	}

	// 킹
	ii = strlen(szOutStr);
	if(ii < n){
		strcpy(szStr,szOutStr);
		memset(szOutStr,' ',CHR_BUF);
		strcpy(szOutStr+(n-ii),szStr);
	}
	
	return (LPCSTR)szOutStr;
}




//----------------------------------------
// vpeBV[gwb_̃R[obN֐
// ÉH폜
int CALLBACK MyPropSheetProc(HWND hWnd,UINT msg,LPARAM lp)
{
	DWORD dwStyle;
	
    switch(msg){
		
	case PSCB_INITIALIZED: // 
		
		// ÉH̍폜
		dwStyle = GetWindowLong(hWnd,GWL_EXSTYLE);
		dwStyle &= ~(DWORD)(WS_EX_CONTEXTHELP);
		SetWindowLong(hWnd,GWL_EXSTYLE,dwStyle );
		
		break;
		
	default:
		break;
	}
	
	return 0;
} 




//-------------------------------------------------------------------
// ݒvpeBV[g\

#define PROCCOUNT 8
LRESULT CALLBACK SettingProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp,BOOL bPropSheet);
LRESULT CALLBACK SettingProcPropSheet(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp){ return SettingProc(hWnd,msg,wp,lp,TRUE);}
LRESULT CALLBACK HighSettingProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK AboutProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK FileSettingProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ToolSettingProc1(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ToolSettingProc2(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ViewSettingProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DevSettingProc(HWND, UINT, WPARAM, LPARAM);

int ShowSettingPropSheet(HWND hWnd,HINSTANCE hInst)
{
	// vV[W̃AhX
	DWORD dwProcAdr[PROCCOUNT]=
	{
		(DWORD)SettingProcPropSheet,
			(DWORD)FileSettingProc,
			(DWORD)ToolSettingProc1,
			(DWORD)ToolSettingProc2,
			(DWORD)DevSettingProc,
			(DWORD)ViewSettingProc,
			(DWORD)HighSettingProc,
			(DWORD)AboutProc
	};
	
	// ^Cg
	LPCSTR lpszTitle[PROCCOUNT]={
		"^̐ݒ",
			"{ݒ",
			"c[1",
			"c[2",
			"foCX",
			"",
			"xȐݒ",
			"o[W"
	};
	
	// _CAO\[X ID
	UINT uDiagID[PROCCOUNT]={
		IDD_SETTINGDIAG,
			IDD_FILESETTINGDIAG,
			IDD_TOOLDIAG1,
			IDD_TOOLDIAG2,
			IDD_DEVSETTINGDIAG,
			IDD_VIEWSETTINGDIAG,
			IDD_HIGHSETTINGDIAG,
			IDD_ABOUTDIAG
	};
	
	PROPSHEETHEADER propSheetHead;
	PROPSHEETPAGE propSheetPage;
	HPROPSHEETPAGE hPropSheetPage[PROCCOUNT];
	
	int i;
	
	//y[Wݒ
	memset(&propSheetPage, 0, sizeof(PROPSHEETPAGE));
	propSheetPage.dwSize = sizeof(PROPSHEETPAGE);
	propSheetPage.dwFlags = PSP_DEFAULT|PSP_USETITLE|PSP_HASHELP;
	propSheetPage.hInstance = hInst;
	
	for(i=0;i<PROCCOUNT;i++){
		propSheetPage.pszTemplate = MAKEINTRESOURCE(uDiagID[i]);
		propSheetPage.pfnDlgProc = (DLGPROC)dwProcAdr[i];
		propSheetPage.pszTitle = lpszTitle[i];
		hPropSheetPage[i] = CreatePropertySheetPage(&propSheetPage);
	}
	
	
	// vpeBV[g̍쐬
	memset(&propSheetHead, 0, sizeof(PROPSHEETHEADER));
	propSheetHead.dwSize = sizeof(PROPSHEETHEADER);
	propSheetHead.dwFlags = PSH_NOAPPLYNOW|PSH_HASHELP|PSH_USECALLBACK;
	propSheetHead.hwndParent = hWnd;
	propSheetHead.hInstance = hInst;
	propSheetHead.pszCaption = "Setup";
	propSheetHead.nPages = PROCCOUNT;
	propSheetHead.nStartPage = 0;
	propSheetHead.pfnCallback = (PFNPROPSHEETCALLBACK)MyPropSheetProc;
	propSheetHead.phpage = hPropSheetPage;
	
	// vpeBV[g\
	return(PropertySheet(&propSheetHead));
}




//----------------------------------------------------------
// {[Rg[Ăяo֐
// NT ̏ꍇ͑dNȂ悤ɂĂB
BOOL ShowVolumeControl(HWND hWnd,UINT uCtrl)
{
	STARTUPINFO startInfo;
	static PROCESS_INFORMATION proInfo;
	CHAR szPath[MAX_PATH],szFile[MAX_PATH];
	WIN32_FIND_DATA findData;
	HANDLE hFind;
	FILETIME crTime,exitTime,krTime,usrTime;
	DWORD dwExitCode;
	static 	FILETIME creationTime;
	
	// ɋNĂȂ`FbN
	GetExitCodeProcess(proInfo.hProcess,&dwExitCode);
	
	if(dwExitCode == STILL_ACTIVE){
		GetProcessTimes(proInfo.hProcess,&crTime,&exitTime,&krTime,&usrTime);
		
		if((crTime.dwHighDateTime == creationTime.dwHighDateTime) &&
			(crTime.dwLowDateTime == creationTime.dwLowDateTime))
			return FALSE;
	}
	
	// Window fBNgɂ邩?
	GetWindowsDirectory(szPath,MAX_PATH);
	wsprintf(szFile,"%s\\sndvol32.exe",szPath);
	hFind = FindFirstFile(szFile,&findData);
	
	// 
	if(hFind==INVALID_HANDLE_VALUE){
		
		// System fBNgɂ邩? 
		GetSystemDirectory(szPath,MAX_PATH);
		wsprintf(szFile,"%s\\sndvol32.exe",szPath);
		hFind = FindFirstFile(szFile,&findData);
		
		// 
		if(hFind==INVALID_HANDLE_VALUE){
			MyMessageBox(hWnd,"{[Rg[CXg[Ă܂B\nRg[pl̃AvP[V̒ǉƍ폜ŃCXg[ĉB",
				"Error",MB_OK|MB_ICONERROR);
			
			return FALSE;
		}
	}
	
	FindClose(hFind); 
	
	// Rg[Ăяo
	wsprintf(szFile,"%s /r /d %d",szFile,uCtrl);
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);
	if(!CreateProcess(NULL,szFile,NULL,NULL,FALSE,0,
		NULL,NULL,&startInfo,&proInfo)){
		MyMessageBox(hWnd,"{[Rg[̋NɎs܂B",
			"Error",MB_OK|MB_ICONERROR);
		return FALSE;
	}
	
	// N܂ő҂
	WaitForInputIdle(proInfo.hProcess,5000);
	
	// NԂL^Ă
	GetProcessTimes(proInfo.hProcess,&creationTime,&exitTime,&krTime,&usrTime);
	
	return TRUE;
	
}



//-------------------------------------------------------------------
// {^̃NCAg̈ɂW擾
VOID GetButtonPos(HWND hWnd,UINT uCtlID,LPRECT lpRt){
	
	LONG parentX,parentY;
	RECT rt;
	
	GetWindowRect(hWnd,&rt);
	
	parentX = rt.left;
	parentY = rt.top;
	
	GetWindowRect(GetDlgItem(hWnd,uCtlID),lpRt);
	
	lpRt->left -= parentX;
	lpRt->right -= parentX;
	lpRt->top -= parentY;
	lpRt->bottom -= parentY;
}



//--------------------------------------------------------
// R}hCN֐
BOOL ExecCommand(LPSTR lpszCommandLine,
				 PROCESS_INFORMATION* pProInfo, // NULL ł OK
				 BOOL bInheritHandles // nhp邩
				 ){
	
	BOOL bReturn;
	STARTUPINFO startInfo;
	PROCESS_INFORMATION proInfo;
	PROCESS_INFORMATION* lpProInfo;
	
	if(pProInfo == NULL) lpProInfo = &proInfo;
	else lpProInfo = pProInfo;
	
	
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);
	bReturn = CreateProcess(NULL,lpszCommandLine,NULL,NULL,bInheritHandles,
		0,NULL,NULL,&startInfo,lpProInfo);
	
	return bReturn;
}




//------------------------------------------
// t@ĈtH_J
VOID OpenCurrentFolder(HWND hWnd,LPSTR lpszFileName)
{
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	CHAR szCommand[CHR_BUF];
	
	_splitpath(lpszFileName,fDrive,fPath,fName,fExt);	
	wsprintf(szCommand,"explorer /e,\"%s%s\"",fDrive,fPath); 

	ExecCommand(szCommand,NULL,FALSE);
}


//------------------------------------------
// bÑtH_J
VOID OpenLockonFolder(HWND hWnd){

	CHAR str[MAX_PATH];
	CHAR fPath[MAX_PATH],fDrive[MAX_PATH],fName[MAX_PATH],fExt[MAX_PATH]; 
	CHAR szCommand[CHR_BUF];

	GetModuleFileName(NULL,str,MAX_PATH);
	_splitpath(str,fDrive,fPath,fName,fExt);	
	wsprintf(szCommand,"explorer /e,\"%s%s\"",fDrive,fPath); 

	ExecCommand(szCommand,NULL,FALSE);
}




//-------------------------------------------------------------------
// PIPE ^s@\̃R}hݒ_CAÕvV[W
LRESULT CALLBACK CommandSettingProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	
	static LPCOMMANDDATA lpCommData;
	static UINT uEditID[MAXCOMMANDNUMBER] = 
	{IDC_EDITCOM1,IDC_EDITCOM2,IDC_EDITCOM3,IDC_EDITCOM4,
	IDC_EDITCOM5,IDC_EDITCOM6,IDC_EDITCOM7,IDC_EDITCOM8,
	IDC_EDITCOM9,IDC_EDITCOM10,IDC_EDITCOM11,IDC_EDITCOM12
	};
	static UINT uCmbID[MAXCOMMANDNUMBER] = 
	{IDC_RBCOM1,IDC_RBCOM2,IDC_RBCOM3,IDC_RBCOM4,
	IDC_RBCOM5,IDC_RBCOM6,IDC_RBCOM7,IDC_RBCOM8,
	IDC_RBCOM9,IDC_RBCOM10,IDC_RBCOM11,IDC_RBCOM12
	};
	static UINT uCmbHeadID[MAXCOMMANDNUMBER] = 
	{IDC_CHKHEAD1,IDC_CHKHEAD2,IDC_CHKHEAD3,IDC_CHKHEAD4,
	IDC_CHKHEAD5,IDC_CHKHEAD6,IDC_CHKHEAD7,IDC_CHKHEAD8,
	IDC_CHKHEAD9,IDC_CHKHEAD10,IDC_CHKHEAD11,IDC_CHKHEAD12
	};
	int i,i2;
	char szTemp[CHR_BUF];
	
	switch (msg) {
		
	case WM_INITDIALOG:  // _CAO
		
		lpCommData = (LPCOMMANDDATA)lp;
		
		// _CAOړ
		SetDlgCenter(hWnd);
		
		// L[{[htH[JXZbg
		// DialogBoxParam ŌĂ񂾏ꍇAȂ
		// L[{[hőłȂȂ
		SetFocus(GetDlgItem(hWnd,IDOK));
		
		for(i=0;i<MAXCOMMANDNUMBER;i++){
			Edit_SetText(GetDlgItem(hWnd,uEditID[i]),(LPCTSTR)lpCommData->lpszCommand+CHR_BUF*i);
			if(i == *(lpCommData->lpwCommandNum)) Button_SetCheck(GetDlgItem(hWnd,uCmbID[i]), BST_CHECKED);
		}
		
		// ^OR}h̎
		if(lpCommData->lpwTimerPreExePrepareTime){
			i = *(lpCommData->lpwTimerPreExePrepareTime);
			SendMessage(GetDlgItem(hWnd,IDC_SPINPREEXE),UDM_SETRANGE,(WPARAM)0,(LPARAM)MAKELONG((short)MAX_PREEXETIMERMIN,1));
			SendMessage(GetDlgItem(hWnd,IDC_SPINPREEXE),UDM_SETPOS,(WPARAM)0L,(LPARAM)MAKELONG((short)i,0));
		}

		// s҂
		if(lpCommData->lpwCommandExeWaitTime){
			i = *(lpCommData->lpwCommandExeWaitTime);
			SendMessage(GetDlgItem(hWnd,IDC_SPINEXEWAIT),UDM_SETRANGE,(WPARAM)0,(LPARAM)MAKELONG((short)MAX_EXEWAITSEC,0));
			SendMessage(GetDlgItem(hWnd,IDC_SPINEXEWAIT),UDM_SETPOS,(WPARAM)0L,(LPARAM)MAKELONG((short)i,0));
		}

		// wb_𑗂邩ǂ
		if(lpCommData->lpdwHeaderOffPipe){
			for(i=0;i<MAXCOMMANDNUMBER;i++){
				if(*(lpCommData->lpdwHeaderOffPipe) & (1<<i)) 
					Button_SetCheck(GetDlgItem(hWnd,uCmbHeadID[i]), BST_CHECKED);
			}
		}

		break;

	case WM_SETCURSOR:  // NbN`FbN{bNXړ

		i=0; while(i < MAXCOMMANDNUMBER && GetDlgItem(hWnd,uEditID[i]) != (HWND)wp) i++;
		if(i == MAXCOMMANDNUMBER) return FALSE;
		if(HIWORD(lp) != WM_LBUTTONDOWN) return FALSE;

		for(i2=0;i2<MAXCOMMANDNUMBER;i2++){
			if(IsDlgButtonChecked(hWnd,uCmbID[i2]) == BST_CHECKED) Button_SetCheck(GetDlgItem(hWnd,uCmbID[i2]), BST_UNCHECKED);
		}
		Button_SetCheck(GetDlgItem(hWnd,uCmbID[i]), BST_CHECKED);

		break;
		
	case WM_COMMAND:
		
		switch (LOWORD(wp)) {
			
		case IDOK: 
			
			for(i=0;i<MAXCOMMANDNUMBER;i++){
				Edit_GetText(GetDlgItem(hWnd,uEditID[i]),(LPTSTR)lpCommData->lpszCommand+CHR_BUF*i,CHR_BUF);
				if(IsDlgButtonChecked(hWnd,uCmbID[i]) == BST_CHECKED) *(lpCommData->lpwCommandNum) = i;
			}

			// ^OR}h̎
			if(lpCommData->lpwTimerPreExePrepareTime){
				*(lpCommData->lpwTimerPreExePrepareTime)
					= min(MAX_PREEXETIMERMIN,(WORD)SendMessage(GetDlgItem(hWnd,IDC_SPINPREEXE),UDM_GETPOS,(WPARAM)0L,(LPARAM)0L));
			}

			// s҂
			if(lpCommData->lpwCommandExeWaitTime){
				*(lpCommData->lpwCommandExeWaitTime)
					= min(MAX_EXEWAITSEC,(WORD)SendMessage(GetDlgItem(hWnd,IDC_SPINEXEWAIT),UDM_GETPOS,(WPARAM)0L,(LPARAM)0L));
			}
			
			// wb_𑗂邩ǂ
			if(lpCommData->lpdwHeaderOffPipe){
				*(lpCommData->lpdwHeaderOffPipe) = 0;
				for(i=0;i<MAXCOMMANDNUMBER;i++){
					if(IsDlgButtonChecked(hWnd,uCmbHeadID[i]) == BST_CHECKED){
						*(lpCommData->lpdwHeaderOffPipe) |= (1<<i);
					}
				}
			}

			EndDialog(hWnd, IDOK);
			
			return TRUE;
			
		case IDCANCEL: 
			
			EndDialog(hWnd, IDCANCEL);
			
			return TRUE;

		case IDC_BTLONDIR:

			OpenLockonFolder(hWnd);
			break;
			
		case IDC_BTREFER: // Qƃ{^
			
			for(i=0;i<MAXCOMMANDNUMBER;i++){
				if(IsDlgButtonChecked(hWnd,uCmbID[i]) == BST_CHECKED) break;
			}
			
			Edit_GetText(GetDlgItem(hWnd,uEditID[i]),(LPSTR)szTemp,CHR_BUF);
			if(SelectExeBatFile(hWnd ,szTemp)) Edit_SetText(GetDlgItem(hWnd,uEditID[i]),(LPSTR)szTemp);
			
			break;
			

		}
		break;
		
		default:
			break;
	}
    return FALSE;
}




//-------------------------------------------------------------------
// }EX|C^^Cgɂ邩ׂ
BOOL OnNcHitTest(HWND hWnd,LONG x,LONG y){
	
	LONG parentX,parentY;
	RECT rt;
	
	// NCAg̈(XN[)W
	GetWindowRect(hWnd,&rt);
	parentX = rt.left;
	parentY = rt.top;
	
	if((parentX <= x && x <= parentX+MAINWIDTH) && 
		(parentY <= y && y <= parentY+CAPTIONHEIGHT)) return TRUE;
	
	return FALSE;
}


//--------------------------------------------------------------------
// V[gJbg쐬֐
#include "shlobj.h"
BOOL CreateShortCut(LPSTR lpszFile,  // V[gJbg𒣂t@C
					LPSTR lpszShortCutFile, // V[gJbgt@C(*.lnk)
					LPSTR lpszArgs,  // NɃAvP[Vɓn
					LPSTR lpszWorkDir, // ƃfBNg
					LPSTR lpszIconFile, // ACR܂łt@C
					int nIcon, // ACR̃CfbNX
					int nCmdShow)  // s̑傫BShowWindow() Q
{
	BOOL bResult = FALSE;
	HRESULT hResult; 
	WCHAR wszStr[MAX_PATH]; // Unicode 
	
	// shell link IuWFNgւ̃|C^
	// (V[gJbg̐ݒIuWFNg)
	IShellLink* pIShLink; 
	
	// IPersistFile IuWFNgւ̃|C^
	// (shell link IuWFNg̃[hyуZ[usIuWFNg)
	IPersistFile* pIPerFile; 
	
	// COM library ̏
	CoInitialize(NULL);
	
	// shell link IuWFNg̍쐬
	hResult = CoCreateInstance((REFCLSID)CLSID_ShellLink,NULL,
		(DWORD)CLSCTX_INPROC_SERVER,(REFIID)IID_IShellLink,(VOID**)&pIShLink);
	
	if (hResult >= 0) // 쐬
	{
		// shell link IuWFNg̐ݒ
		pIShLink->SetPath(lpszFile); // Ώۃt@C
		pIShLink->SetArguments(lpszArgs); // NɃt@Cɓn
		pIShLink->SetWorkingDirectory(lpszWorkDir); // ƃfBNg
		pIShLink->SetIconLocation(lpszIconFile,nIcon);  // ACR
		pIShLink->SetShowCmd(nCmdShow); // s̑傫
		
		// Őݒ肵 shell link IuWFNgɑΉ
		// IPersistFile IuWFNg̍쐬
		hResult = pIShLink->QueryInterface((REFIID)IID_IPersistFile,(VOID**)&pIPerFile);
		
		if(hResult >= 0) // 쐬
		{
			// Unicode ֕ϊ
			MultiByteToWideChar(CP_ACP,0,lpszShortCutFile,-1,wszStr,MAX_PATH);
			
			// n[hfBXNɃV[gJbg
			hResult = pIPerFile->Save(wszStr, TRUE);
			
			// IPersistFile IuWFNg̍폜
			pIPerFile->Release();
			
			bResult = TRUE;
		}
		
		// shell link IuWFNg ̍폜
		pIShLink->Release();
	}
	
	// COM library  ̃N[Y
	CoUninitialize();
	
	return(bResult);
}


//----------------------------------------------------
// fXNgbvX^[gj[ɃV[gJbg֐
VOID MakeLockOnShortCut(BOOL bDeskTop,BOOL bStartMenu,BOOL bStartUp)
{
	CHAR szFile[MAX_PATH];  // V[gJbg𒣂t@C
	CHAR szShortCutFile[MAX_PATH]; // V[gJbgt@C(*.lnk)
	CHAR szArgs[MAX_PATH];  // NɃAvP[Vɓn
	CHAR szWorkDir[MAX_PATH]; // ƃfBNg
	CHAR szIconFile[MAX_PATH]; // ACR܂łt@C
	int nIcon; // ACR̃CfbNX
	int nShortCutCmdShow;  // s̑傫
	
	LPITEMIDLIST lpItemID; // ACeXg̃|C^
	CHAR szPath[MAX_PATH];
	CHAR szGroupName[MAX_PATH]; 
	CHAR szDriveName[MAX_PATH],szPathName[MAX_PATH];
	
	// ݒ
	GetModuleFileName(NULL,szFile,MAX_PATH);
	
	wsprintf(szArgs,"");
	
	_splitpath(szFile,szDriveName,szPathName,NULL,NULL);	
	wsprintf(szWorkDir,"%s%s",szDriveName,szPathName);
	
	wsprintf(szIconFile,szFile);
	nIcon = 0;
	nShortCutCmdShow = SW_SHOW;
	
	// fXNgbvɍ쐬
	if(bDeskTop){
		SHGetSpecialFolderLocation(NULL,CSIDL_DESKTOP,&lpItemID) ;
		SHGetPathFromIDList(lpItemID,szPath) ;
		wsprintf(szShortCutFile,"%s\\LOCK ON.lnk",szPath);
		
		CreateShortCut(szFile,szShortCutFile,szArgs,szWorkDir,szIconFile,nIcon,nShortCutCmdShow);
	}

	// X^[gAbvɍ쐬
	if(bStartUp){
		SHGetSpecialFolderLocation(NULL,CSIDL_STARTUP,&lpItemID) ;
		SHGetPathFromIDList(lpItemID,szPath) ;
		wsprintf(szShortCutFile,"%s\\LOCK ON.lnk",szPath);
		wsprintf(szArgs,"-icon");
		
		CreateShortCut(szFile,szShortCutFile,szArgs,szWorkDir,szIconFile,nIcon,nShortCutCmdShow);
	}
	
	// vOj[ɍ쐬
	if(bStartMenu){
		SHGetSpecialFolderLocation(NULL,CSIDL_PROGRAMS ,&lpItemID) ;
		SHGetPathFromIDList(lpItemID,szPath) ;
		wsprintf(szGroupName,"%s\\LOCK ON",szPath);
		
		CreateDirectory(szGroupName,NULL); // tH_쐬
		
		wsprintf(szShortCutFile,"%s\\LOCK ON.lnk",szGroupName);
		CreateShortCut(szFile,szShortCutFile,szArgs,szWorkDir,szIconFile,nIcon,nShortCutCmdShow);
		
		// wṽV[gJbg
		wsprintf(szFile,"%shelp.htm",szWorkDir);
		wsprintf(szIconFile,"");
		nIcon = 0;
		wsprintf(szShortCutFile,"%s\\Help.lnk",szGroupName);
		CreateShortCut(szFile,szShortCutFile,szArgs,szWorkDir,szIconFile,nIcon,nShortCutCmdShow);
	}
}



//----------------------------------------------------
// ɋNĂ LOCKON  HWND 𓾂֐
BOOL CALLBACK SearchLockOnProc(HWND,LPARAM);

HWND GetPreLockOnHWND(){
	
	HWND hResultWnd = NULL;
	
	EnumWindows((WNDENUMPROC)SearchLockOnProc,(LPARAM)&hResultWnd);
	
	return hResultWnd;
}


//----------------------------------------------------
// EnumWindows ̃R[obN֐
BOOL CALLBACK SearchLockOnProc(HWND hWnd,LPARAM lp){
	
	CHAR szTitle[CHR_BUF];
	
	GetWindowText(hWnd,szTitle,CHR_BUF);
	
	if(!strncmp(szTitle,"LOCK ON",7)){
		*((HWND*)lp) = hWnd;
		return FALSE;
	}
	
	return TRUE;
}






//------------------------------------------------------------------------
// ̃TEhJ[h(PSC706)ƕAɘ^悤
// Ƙ^oȂƂBŁÃvZX
// waveInGetNumDevs() ĂԂƃTEhJ[hX[v
// 畜Â waveInGetNumDevs() ŌĂڂ
// v̂foCXAȂ̂ŁAЂƂ
// lockon N waveInGetNumDevs() ĂŃfoCX
// AĂ炷ɏIƂrƂɏo
void WINAPI ExecLockonAtWakeUp(LPVOID lpVoid){

	DWORD dwSleep = (DWORD)lpVoid;

	Sleep(dwSleep);
	ExecCommand("lockon -resume",NULL,FALSE);

}



//EOF
