//------------------------
// WAVE ^֐   HDD,PIPE   2003/1/7 
//
// (c) 1998-2003 tokai@main.eng.hokudai.ac.jp
//
// {vÔׂāA܂͈ꕔ GPL ɏ]čĔЕz܂͕ύX
// Ƃł܂BڍׂɂĂGNU ʌLgpǂ݂B

#include <windows.h>
#include <mmsystem.h>
#include "common.h"
#include "resource.h"
#include "wave.h"


#define WAVEHDR_MAXBUF 64  // WAVE wb_̐ Max
#define WAVEHDR_SETNUM 4 // foCXɃZbgĂwb_̐


// Xe[^X
#define ID_PREPARE		0
#define ID_OPENWAVE		1
#define ID_LOOP			2
#define ID_PAUSE		3
#define ID_EXITLOOP		4
#define ID_CLOSEWAVE	5


// ʂ̊֐(wavefunc.cpp )
BOOL SetHeapWaveHdr(HWND,HANDLE,LPBYTE*,LPWAVEHDR,LONG,DWORD);
VOID SetDlgCenter(HWND);
VOID WriteWaveHeader(HANDLE hdWriteFile,LPWAVEFORMATEX lpWaveFmt,LONGLONG n64WaveDataSize
					 ,BOOL bUseExtChunk);


VOID WaveLevelMaxPeak(double dPeak[2],
					  LPBYTE lpWaveData,  // data
					  DWORD dwWaveBlockByte, // byte, size of data
					  WAVEFORMATEX waveFmt);
void SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,
				DWORD waveRate,	WORD waveBit, WORD wTag);

// bZ[W{bNX
int MyMessageBox(HWND,LPSTR,LPSTR,UINT);
int MyMessageBoxEx(HWND hWnd,LPSTR lpText,LPSTR lpCaption,UINT uType,
						 DWORD dwTimer,BOOL bStayOnTop,BOOL bCenter);

//commonfunc.cpp ̊֐
VOID GetFreeHddSpace64(ULONGLONG*,LPSTR);
HWND GetConsoleWindowHandle();
BOOL ExecCommand(LPSTR,PROCESS_INFORMATION*,BOOL);
void GetDataSize(WAVEFORMATEX waveFmt,DWORD dwRecTime, LONGLONG* lpn64Size);

// log
void WriteLog(char* szLog);

// main.cpp
DWORD GetMouseMoveTime();


// ̃t@C̊֐
DWORD WINAPI RecWaveThread(LPVOID);



// ^RAɓnf[^^
typedef struct
{
	HWND hWnd;
	UINT uDeviceID;
}COREDATA,*LPCOREDATA;


// O[oϐ
HANDLE HdRecThread[MAX_RECTHREAD]; // Xbh̃nh
WORD RecStatus[MAX_RECTHREAD]; // ݂̃Xe[^X
HANDLE HdFile[MAX_RECTHREAD]; // t@C̃nh
PROCESS_INFORMATION ProcessInfo[MAX_RECTHREAD]; // qvZX
RECTHREADDATA RecThreadData[MAX_RECTHREAD]; // Xbh
LPBYTE LpForceMonoData[MAX_RECTHREAD]; // Eʘ^̍Ɨ̈p

	
BOOL BoolDebugMode;  // fobO[hǂ

// ^RAp
HWAVEIN HdWaveIn;  // ^foCX̃nh
DWORD DwCoreStatus;
HANDLE HdCoreThread;
DWORD DwCoreWaveBlockByte;
WAVEHDR WaveHdr[WAVEHDR_MAXBUF]; // wave wb_̃obt@
HANDLE HdHeap; // q[vnh
DWORD DwReadWaveHdr;  // ǂݍݒ wave wb_̔ԍ
DWORD DwCurWaveHdr;  // ۑ̂҂Ă wave wb_̔ԍ
DWORD DwCurWaveHdrLock;
DWORD DwCurWaveHdrLockMask;
WAVEFORMATEX WaveFmtCore;
DWORD DwWaveHdrNumber; // wave wb_̐


// rpZ}tH
HANDLE HsempLock;   
HANDLE HcoreLock;   // RAp
HANDLE HrecLock;    // ^Xbhp


//-------------------------------------
// ֐
VOID PrepareRecWave()
{
	DWORD i;

	for(i=0;i<MAX_RECTHREAD;i++){
		HdRecThread[i] = NULL;
		RecThreadData[i].dwRecStatus = ID_CLOSEWAVE;
		HdFile[i] = NULL;
		ProcessInfo[i].hProcess = NULL;
		LpForceMonoData[i] = NULL;
	}
	BoolDebugMode = FALSE;

	HdWaveIn = NULL;
	DwCoreStatus = ID_CLOSEWAVE;
	DwCurWaveHdrLockMask = 0;
	HdCoreThread = NULL;
	HdHeap = NULL;

	// Z}tH̏
	// Z}tHłȂăNeBJZNVgƂƃbN|Ȃ̂Œ
   HsempLock = CreateSemaphore(NULL,1,1,NULL);
   HcoreLock = CreateSemaphore(NULL,1,1,NULL);
   HrecLock = CreateSemaphore(NULL,1,1,NULL);
}


//-------------------------------------
// I֐
VOID UnPrepareRecWave(){
   CloseHandle(HsempLock);
   CloseHandle(HcoreLock);
   CloseHandle(HrecLock);
}


//-------------------------------------
// Ă^Xbh邩`FbN
// Xbh̐Ԃ
DWORD CheckThreadMoving()
{
	DWORD i;
	DWORD dwRet = 0;

	for(i=0;i<MAX_RECTHREAD;i++) if(HdRecThread[i] != NULL) dwRet++;

	return dwRet;
}


//-------------------------------------
// ĂȂ^Xbh ID 擾
DWORD GetNoMovingThreadID()
{
	DWORD dwThread;

	// ĂȂXbhT
	for(dwThread=0;dwThread<MAX_RECTHREAD;dwThread++) if(HdRecThread[dwThread] == NULL) break;

	if(dwThread == MAX_RECTHREAD) dwThread = -1;

	return dwThread;
}



//-------------------------------------
// RAĂ邩`FbN
BOOL CheckCoreMoving()
{
	if(HdCoreThread != NULL) return TRUE;

	return FALSE;
}


//-------------------------------------
// Xbh擾
// łɓĂ邩ǂ`FbN
BOOL GetThreadInfo(LPRECTHREADDATA lpThDat,DWORD dwThread)
{
	if(HdRecThread[dwThread] == NULL) return FALSE;

	if(lpThDat != NULL) *lpThDat = RecThreadData[dwThread];
	return TRUE;
}


//-------------------------------------
// R\[\֌W

// fobO[h؂ւ
void SetPipeDebugMode()
{
	if(!BoolDebugMode){
		AllocConsole();
		BoolDebugMode = TRUE;
	}
	else{
		FreeConsole();
		BoolDebugMode = FALSE;
	}
	
}

void MyFreeConsole(){
	if(!BoolDebugMode) FreeConsole();
}

void MyAllocConsole(LPSTR lpCommand)
{
	DWORD dwByte;
	CHAR szTmp[MAX_COM_LNG];
	
	if(!BoolDebugMode) AllocConsole();
	else
	{
		wsprintf(szTmp,"\r\n-----\r\ncommand: %s\r\n-----\r\n",lpCommand);
		WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), szTmp,strlen(szTmp),&dwByte, NULL);
	}
}


//-----------------------------------------
// pCvăR}hCs֐
#define READ 0
#define WRITE 1
BOOL ExecPipeCommand(LPSTR lpApplicationName,
					 LPSTR lpszPipeCom,
					 PROCESS_INFORMATION* pProInfo,
					 LPPIPEHANDLE lpPipeHandle,
					 DWORD dwPipeSize,
					 BOOL bShowConsole, // R\[Jǂ
					 LPSTR lpszErr){
	
	HANDLE hPipeP2C[2];  // e  q ̃pCv(stdin)
	HANDLE hOldIn;
	BOOL bRet;
	DWORD dwMode;
	DWORD dwCreationFlags;
	
	STARTUPINFO startInfo;
	SECURITY_ATTRIBUTES secAtt;

	// SECURITY_ATTRIBUTES ̐ݒ
	secAtt.nLength = sizeof(SECURITY_ATTRIBUTES);
	secAtt.lpSecurityDescriptor = NULL;
	secAtt.bInheritHandle = TRUE;  // nhp
	
	// STARTUPINFO ̐ݒ
	memset(&startInfo,0,sizeof(STARTUPINFO));
	startInfo.cb = sizeof(STARTUPINFO);
	
	// pCv쐬
	if(!CreatePipe(&hPipeP2C[READ],&hPipeP2C[WRITE],&secAtt,dwPipeSize))
	{
		if(lpszErr != NULL) wsprintf(lpszErr,"pCv̍쐬Ɏs܂Bobt@TCYĉ");
		return FALSE;
	}

	// nh
	// pCv̏ݑ(eCg鑤)͎qvZXɌpȂ̂ŁA
	// ݑ̃nhRs[ăN[YƂ
	if(!DuplicateHandle(lpPipeHandle->hParent,hPipeP2C[WRITE],lpPipeHandle->hParent,&(lpPipeHandle->hPipeP2Cin),0,FALSE,DUPLICATE_SAME_ACCESS))
	{
		if(lpszErr != NULL) wsprintf(lpszErr,"nh̕Ɏs܂");
		CloseHandle(hPipeP2C[READ]);
		CloseHandle(hPipeP2C[WRITE]);
		return FALSE;
	}
	CloseHandle(hPipeP2C[WRITE]); 
	
	// stdin ۑ
	hOldIn = GetStdHandle(STD_INPUT_HANDLE);
	
	if(bShowConsole)
	{
		// R\[\
		MyFreeConsole();
		Sleep(100); 
		MyAllocConsole(lpszPipeCom);
		Sleep(300); // NT ̏ꍇ Sleep ȂƏdȂ(?)
		
		//Ctrl+C 𖳌ɂ
		GetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),&dwMode);
		SetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),dwMode&~ENABLE_PROCESSED_INPUT);
		
		// uqvvZX STDIN Zbg
		// qvZX inherit ĎqvZXN߂
		SetStdHandle(STD_INPUT_HANDLE,hPipeP2C[READ]);

		dwCreationFlags = CREATE_NEW_PROCESS_GROUP;
	}
	else
	{
		// R\[\
		startInfo.dwFlags = STARTF_USESTDHANDLES|STARTF_USESHOWWINDOW;
		startInfo.wShowWindow = SW_HIDE;
		startInfo.hStdInput = hPipeP2C[READ]; 

		dwCreationFlags = CREATE_NEW_PROCESS_GROUP;
	}
	
	// vZXN
	if(!(bRet = CreateProcess(lpApplicationName,lpszPipeCom,NULL,NULL,TRUE,
		dwCreationFlags,NULL,NULL,&startInfo,pProInfo)))
	{
		if(lpszErr != NULL) wsprintf(lpszErr,"vZX̋NɎs܂");
	}
	
	// qvZXN stdin ߂ăpCvN[Y
	SetStdHandle(STD_INPUT_HANDLE,hOldIn);
	CloseHandle(hPipeP2C[READ]);
	
	return bRet;
}
#undef WRITE
#undef READ




//-------------------------------------------------------------------
// wave in ̃R[obN֐
VOID CALLBACK MyWaveInProc(HWAVEOUT hWaveOut,UINT msg,DWORD inst,DWORD dwP1,DWORD dwP2)
{
	switch (msg) 
	{
		
	case WIM_OPEN: // WAVE foCXI[v
		DwCoreStatus = ID_OPENWAVE;
		break;
		
	case WIM_CLOSE: // WAVE foCXN[Y
		DwCoreStatus = ID_CLOSEWAVE;
		break;
		
	default:
		break;
    }
}



//-------------------------------------------------------------------
// WAVE f[^
BOOL WriteRecWaveData(HANDLE hdFile,
					  LPBYTE lpWaveData,
					  DWORD dwDataByte, // ݃f[^TCY
					  WORD wBitsPerSample,
					  WORD wForceMono, // m[h
					  LPBYTE lpBuf, // Ɨpobt@
					  LPOVERLAPPED lpOverLapped)
{
	DWORD dwByte,i; 
	DWORD dwOffset,dwBlockByte;
	
	if(wForceMono == FORCE_MONO_OFF)
	{ // ʏ탂[h
		if(WriteFile(hdFile, lpWaveData, dwDataByte, &dwByte, lpOverLapped)==0){
			return FALSE;
		}
		if(dwDataByte != dwByte) return FALSE;
	}
	else
	{ // m[h
		if(wForceMono == FORCE_MONO_LEFT) dwOffset = 0; 
		else dwOffset = 1;
		if(wBitsPerSample == 8) dwBlockByte = 1; 
		else if(wBitsPerSample == 16) dwBlockByte = 2;
		else if(wBitsPerSample == 24) dwBlockByte = 3;
		else if(wBitsPerSample == 32) dwBlockByte = 4;
		for(i=0;i<dwDataByte; i+= dwBlockByte*2)
			CopyMemory(lpBuf+i/2,lpWaveData+i+dwOffset*dwBlockByte,dwBlockByte);

		if(WriteFile(hdFile, lpBuf, dwDataByte/2, &dwByte, lpOverLapped)==0) return FALSE;
		if(dwDataByte/2 != dwByte) return FALSE;
	}
	
	return TRUE;
}


//-------------------------------------------------------------------
// vZX~Ă܂̃_CAÕvV[W(^C}[)
LRESULT CALLBACK PipeStopProcTimer(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static UINT uTimerID = 0; 
	switch (msg) 
	{
	case WM_INITDIALOG: 
		SetDlgCenter(hWnd);	
		uTimerID = SetTimer(hWnd, 1,(DWORD)lp, NULL); 
		break;
	case WM_TIMER: 
			KillTimer(hWnd, uTimerID);
			EndDialog(hWnd, IDOK);
			break;
	case WM_CLOSE: 
		EndDialog(hWnd,IDCANCEL);
		break;
	}

    return FALSE;
}


//-------------------------------------------------------------------
// vZX~Ă܂̃_CAÕvV[W(ʏ)
LRESULT CALLBACK PipeStopProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) 
	{
	case WM_INITDIALOG: 
		SetDlgCenter(hWnd);	
		break;
	case WM_CLOSE: 
		EndDialog(hWnd,IDCANCEL);
		break;
	}

    return FALSE;
}


//---------------------------------------
// w肵Xbh̃G[I
// t@CN[Y & qvZX~ 
// ) Xbĥ̓^[~l[gȂARA̒~͂Ȃ
VOID ExitRecError(HWND hWnd,DWORD dwThread)
{
	DWORD dwExitCode;
	
	// t@CN[YApCv̏ꍇ EOF 
	if(HdFile[dwThread] != NULL) CloseHandle(HdFile[dwThread]);	 	
	HdFile[dwThread] = NULL;

	// Ɨ̈惁J
	if(LpForceMonoData[dwThread]) GlobalFree(LpForceMonoData[dwThread]);

	// qvZX~
	if(ProcessInfo[dwThread].hProcess != NULL)
	{
		// Ctrl+C  Ctrl+break MĂ΂炭҂
		DWORD dwMode;
		GetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),&dwMode);
		SetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),dwMode|ENABLE_PROCESSED_INPUT);
		Sleep(100);
		GenerateConsoleCtrlEvent(CTRL_C_EVENT,ProcessInfo[dwThread].dwProcessId);
		GenerateConsoleCtrlEvent(CTRL_BREAK_EVENT,ProcessInfo[dwThread].dwProcessId);
		WaitForSingleObject(ProcessInfo[dwThread].hProcess,2500);
		
		// łĂ Terminate
		GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
		if(dwExitCode == STILL_ACTIVE) 
		{
			TerminateProcess(ProcessInfo[dwThread].hProcess,2);
			WaitForSingleObject(ProcessInfo[dwThread].hProcess,2000);
			
			// łĂx
			GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
			if(dwExitCode == STILL_ACTIVE)
				MyMessageBox(hWnd,"vZX̉܂BbNIĉ","LOCK ON", MB_OK|MB_ICONWARNING);
		}
	}
	ProcessInfo[dwThread].hProcess = NULL;
	
	Sleep(100);
}



//------------------------------------------------------
// ^RA̋~
// RAXbhEăfoCXN[Y
BOOL ForceStopCore(HWND hWnd)
{
	MMRESULT mmResult;
	DWORD i,dwWaitTime;
	CHAR szStr[CHR_BUF];
	
	// ƂɂXbh~
	if(HdCoreThread != NULL)
	{
		if(TerminateThread(HdCoreThread,1)==0)
			MyMessageBox(hWnd,"^Xbh~ł܂BRs[^ċNĂB","Error", MB_OK|MB_ICONERROR);
		Sleep(200); 
	}
	
	// TEhfoCXN[Y
	if(HdWaveIn != NULL)
	{
		// ^~
		mmResult = waveInReset(HdWaveIn);
		if(mmResult != MMSYSERR_NOERROR) 
		{
			wsprintf(szStr, "^~ł܂(%d)(ExitRec)",mmResult);
			MyMessageBox(hWnd, szStr,"Error", MB_OK|MB_ICONERROR);
		}
		
		Sleep(200); 
		
		// obt@̌n
		for(i=0;i<DwWaveHdrNumber;i++)
			waveInUnprepareHeader(HdWaveIn,&WaveHdr[i],sizeof(WAVEHDR));
		
		// foCXN[Y
		mmResult = waveInClose(HdWaveIn);
		if(mmResult != MMSYSERR_NOERROR)
		{
			wsprintf(szStr, "^foCX̃N[YɎs܂(%d)(ExitRec)\n\nRs[^ċNĉ",mmResult);
			MyMessageBox(hWnd, szStr,"Error", MB_OK|MB_ICONERROR);
		}
		else
		{ 
			// N[Y܂Œ~
			i=0; dwWaitTime = 500;
			while(DwCoreStatus != ID_CLOSEWAVE && i < dwWaitTime)
			{
				Sleep(10);
				i++;
			}
			if(i>=dwWaitTime)
			{
				wsprintf(szStr, "^foCX̃N[YɎs܂(%d)(ExitRec)\n\nRs[^ċNĉ",mmResult);
				MyMessageBox(hWnd, szStr,"LOCK ON", MB_OK|MB_ICONERROR);
			}
		}
	}
	
	// q[v폜
	if(HdHeap)
	{
		if(HeapDestroy(HdHeap) == 0)
		{
			MyMessageBox(hWnd, "̊JɎs܂\n\nbNċNĂ","LOCK ON", MB_OK|MB_ICONERROR);
		}
	}
	
	Sleep(100);
	
	// Xbh~
	HdCoreThread = NULL;
	HdWaveIn= NULL;
	HdHeap = NULL;
	
	return TRUE;
}



//-------------------------------------------------------------------
// w肵Xbh̋~֐
// XbhE ExitRecError() Ă
VOID ForcedStopRecWave(HWND hWnd,DWORD dwThread)
{
	HINSTANCE hInst;
	HWND hDlgWnd;
	
	// XbhĂ
	if(HdRecThread[dwThread] != NULL)
	{
		// u~Ă܂v_CAO\
		hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
		hDlgWnd = CreateDialog(hInst,MAKEINTRESOURCE(IDD_PIPESTOP),hWnd,(DLGPROC)PipeStopProc);
		ShowWindow(hDlgWnd,SW_SHOW);
		UpdateWindow(hDlgWnd);
		
		// ƂɂXbh~
		if(HdRecThread[dwThread])
		{
			if(TerminateThread(HdRecThread[dwThread],1)==0)
				MyMessageBox(hWnd,"Xbh~ł܂BRs[^ċNĂB","LOCKON", MB_OK|MB_ICONERROR);
			
			//~
			ExitRecError(hWnd,dwThread);
			
			// Xbh~
			HdRecThread[dwThread] = NULL;
			RecThreadData[dwThread].dwRecStatus = ID_CLOSEWAVE;
			
			// e MM_WIM_CLOSE 𑗐M
			SendMessage(hWnd,MM_WIM_CLOSE,(WPARAM)dwThread,WIMCLOSE_ERR);
			
			// R\[
			MyFreeConsole();
		}
		
		DestroyWindow(hDlgWnd);
	}
}





//-------------------------------------------------------------------
// SẴXbh̋~֐
VOID ForcedStopRecWaveAll(HWND hWnd)
{
	DWORD dwThread;

	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return;
	ForceStopCore(hWnd);
	for(dwThread=0;dwThread<MAX_RECTHREAD;dwThread++) ForcedStopRecWave(hWnd,dwThread);
	ReleaseSemaphore(HsempLock,1,NULL);
}




//-------------------------------------------------------------------
// w肵Xbh̒ʏ̒~֐
// Xe[^X ID_EXITLOOP ɂăXbh~܂܂ő҂
BOOL ExecStopRecWave(HWND hWnd, WORD wWaitTime,DWORD dwThread)
{
	HINSTANCE hInst;
	DWORD i,i2;
	
	// [v𔲂
	if(RecThreadData[dwThread].dwRecStatus < ID_EXITLOOP) 
		RecThreadData[dwThread].dwRecStatus = ID_EXITLOOP;  

	//---------------------
	// qvZX~
	if(ProcessInfo[dwThread].hProcess != NULL)
	{
		// Ȃ񂩒m񂪃pCvl܂ĂďIȂ̂
		// ƃVbN^邽߂Ƀ_CAO\Ă΂炭҂
		hInst = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
		
		for(i=0;i<16;i++)
		{
			if(i < 4) i2 = 200;
			else if(i<7) i2 = 500;
			else i2 = 1000;
			DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_PIPESTOP),hWnd,(DLGPROC)PipeStopProcTimer,(LPARAM)i2);
			
			if(ProcessInfo[dwThread].hProcess == NULL) break;
		}
		
		// łIĂȂ
		if(ProcessInfo[dwThread].hProcess != NULL)
		{
			if(wWaitTime)
			{ // ^C}[Nċ~
				if(MyMessageBoxEx(hWnd,"^Xbh̉܂B\n\n^C}[IɃXbh~܂BOK ƒɋ~܂B\n\n蓮ŋ~ꍇ̓LZAShift Ȃ~{^ĉB",
					"LOCK ON", MB_OKCANCEL|MB_ICONWARNING|MB_DEFBUTTON2,wWaitTime,FALSE,FALSE)
					== IDOK)
				{
					ForceStopCore(hWnd);
					ForcedStopRecWave(hWnd,dwThread);
				}
			}
			else
				MyMessageBox(hWnd,"^Xbh̉܂B\n\nShift Ȃ~{^ċ~ĂB","LOCK ON", MB_OK|MB_ICONWARNING);
			
			return FALSE;
		}
	}
	
	return TRUE;
}



//-------------------------------------------------------------------
// SẴXbh~߂֐
BOOL StopRecWaveAll(HWND hWnd,WORD wWaitTime)
{
	BOOL bRet = TRUE;
	DWORD dwThread;
	
	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;

	for(dwThread=0;dwThread<MAX_RECTHREAD;dwThread++)
	{
		if(HdRecThread[dwThread] != NULL && RecThreadData[dwThread].dwRecStatus >= ID_LOOP)
			bRet &= ExecStopRecWave(hWnd,wWaitTime,dwThread);
	}

	ReleaseSemaphore(HsempLock,1,NULL);
	
	return bRet;
}




//-------------------------------------------------------------------
// w肵Xbh~߂֐
BOOL StopRecWave(HWND hWnd,WORD wWaitTime,DWORD dwThread)
{
	BOOL bRet = TRUE;
	
	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;

	if(HdRecThread[dwThread] != NULL && RecThreadData[dwThread].dwRecStatus >= ID_LOOP)
		bRet &= ExecStopRecWave(hWnd,wWaitTime,dwThread);

	ReleaseSemaphore(HsempLock,1,NULL);
	
	return bRet;
}



//-------------------------------------------------------------------
// ^{^Ę^Jn֐
BOOL RecWave(HWND hWnd,UINT uDeviceID,LPSTR lpszFileName,WAVEFORMATEX waveFmt,
			 WORD wWaveHdrNumber,
			 DWORD dwWaveBlockByte,
			 DWORD dwRecTime, // ^(b)
			 WORD threadPriority,BOOL bDiskCache,BOOL bPauseRec,BOOL bMarginCheck,
			 BOOL fSave,
			 WORD wSaveMode,
			 WORD wForceMono,
			 LPSTR lpszPipeCom,
			 LPSTR lpszAftCom,
			 DWORD dwAftComWait,
			 BOOL bOpenConsole,
			 DWORD dwPipeSize,
			 BOOL bHeaderOffPipe, // PIPEwb_𑗂Ȃ
			 BOOL bAdjustWriteTime, // ^ = XVԂɃZbg
			 DWORD dwWimNum, // WIM_DATA őԍ
			 BOOL bClose,	// ^I邩ǂ
			 DWORD dwMouseMoveTime // Ŏw肵b̊ԃ}EX͂΃R}hs
			 )
{
	DWORD dwThreadId;
	BOOL bRet = FALSE;
	DWORD dwThread,i;
	
	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;

	// ĂȂXbhT
	for(dwThread=0;dwThread<MAX_RECTHREAD;dwThread++) if(HdRecThread[dwThread] == NULL) break;
	
	if(dwThread == MAX_RECTHREAD)
	{ // XbhĂ߂
		MyMessageBox(hWnd,"ɃXbhĂ܂B^Jnł܂B","LOCK ON", MB_OK|MB_ICONERROR);	
		goto L_ERR;
	}
	
	if(strlen(lpszFileName) >= MAX_PATH)
	{
		MyMessageBox(hWnd,"t@C܂BZĂ","LOCK ON", MB_OK|MB_ICONERROR);	
		goto L_ERR;
	}
	if(strlen(lpszPipeCom) >= MAX_COM_LNG)
	{
		MyMessageBox(hWnd,"pCṽR}h܂BZĂ","LOCK ON", MB_OK|MB_ICONERROR);	
		goto L_ERR;
	}
	if(strlen(lpszAftCom) >= MAX_COM_LNG)
	{
		MyMessageBox(hWnd,"^R}h܂BZĂ","LOCK ON", MB_OK|MB_ICONERROR);
		goto L_ERR;
	}	

	// ̃Xbh|[Y̎̓|[Y
	for(i=0;i<MAX_RECTHREAD;i++)
	{
		if(HdRecThread[i])
		{
			 if(RecThreadData[i].dwRecStatus == ID_PAUSE) 
			{  
				DwCurWaveHdr = DwReadWaveHdr;	// obt@̃f[^j
				RecThreadData[i].dwRecStatus = ID_LOOP; 
				RecThreadData[i].bPauseRec = FALSE;
			}
		}
	}
	
	// XbhZbg
	RecThreadData[dwThread].hWnd = hWnd;
	RecThreadData[dwThread].uDeviceID = uDeviceID;
	strcpy(RecThreadData[dwThread].szFileName,lpszFileName);
	RecThreadData[dwThread].waveFmt = waveFmt;
	RecThreadData[dwThread].wWaveHdrNumber = wWaveHdrNumber;
	RecThreadData[dwThread].dwWaveBlockByte = dwWaveBlockByte;
	RecThreadData[dwThread].dwRecTime = dwRecTime;
	RecThreadData[dwThread].bDiskCache = bDiskCache;
	RecThreadData[dwThread].bPauseRec = bPauseRec;
	RecThreadData[dwThread].bMarginCheck = bMarginCheck;
	strcpy(RecThreadData[dwThread].szPipeCom,lpszPipeCom);
	strcpy(RecThreadData[dwThread].szAftCom,lpszAftCom);
	RecThreadData[dwThread].dwAftComWait = dwAftComWait;
	RecThreadData[dwThread].bOpenConsole = bOpenConsole;
	RecThreadData[dwThread].dwPipeSize = dwPipeSize;
	RecThreadData[dwThread].wForceMono = wForceMono;
	RecThreadData[dwThread].bHeaderOffPipe = bHeaderOffPipe;
	RecThreadData[dwThread].dwWimNum = dwWimNum;
	RecThreadData[dwThread].wSaveMode = wSaveMode;
	RecThreadData[dwThread].bAdjustWriteTime = bAdjustWriteTime;	
	RecThreadData[dwThread].bClose = bClose;
	RecThreadData[dwThread].dwMouseMoveTime = dwMouseMoveTime;
	
	// XbhN
	HdRecThread[dwThread] = CreateThread(NULL,0,
		(LPTHREAD_START_ROUTINE)RecWaveThread,
		(LPVOID)dwThread,0,(LPDWORD)&dwThreadId);
	
	if(HdRecThread[dwThread] == NULL)
	{
		MyMessageBox(hWnd,"Xbh̋NɎs܂B","LOCK ON", MB_OK|MB_ICONERROR);
		goto L_ERR;
	}
	
	//vCIeBݒ
	if(threadPriority==THREAD_HIGH) SetThreadPriority(HdRecThread[dwThread],THREAD_PRIORITY_HIGHEST);
	else if(threadPriority==THREAD_LOW) SetThreadPriority(HdRecThread[dwThread],THREAD_PRIORITY_LOWEST);
	
	bRet = TRUE;
	
L_ERR:

	ReleaseSemaphore(HsempLock,1,NULL);
	
	return bRet;
}
  



//-------------------------------------------------------------------
// |[Y֐
BOOL PauseRecWave(BOOL bBackRec)
{
	BOOL bRet = FALSE;
	DWORD dwThread;
	
	if(WaitForSingleObject(HsempLock,1) == WAIT_TIMEOUT) return FALSE;
	
	for(dwThread=0;dwThread<MAX_RECTHREAD;dwThread++)
	{
		if(HdRecThread[dwThread] != NULL)
		{ 
			// XbhĂ
			if(RecThreadData[dwThread].dwRecStatus == ID_LOOP)
			{  // ^Ȃ|[Y
				RecThreadData[dwThread].dwRecStatus = ID_PAUSE;  
				bRet = TRUE;
			}
			// |[Y
			else if(RecThreadData[dwThread].dwRecStatus == ID_PAUSE) 
			{  
				if(!bBackRec) DwCurWaveHdr = DwReadWaveHdr;	// obt@̃f[^j
				RecThreadData[dwThread].dwRecStatus = ID_LOOP; 
				bRet = TRUE;
			}
			// ɉꂽ炷ҋ@Ԃ
			else if(RecThreadData[dwThread].dwRecStatus == ID_PREPARE)
			{ 
				RecThreadData[dwThread].bPauseRec = TRUE;
				bRet = TRUE;
			}

		}
	}
	
	ReleaseSemaphore(HsempLock,1,NULL);
	
	return bRet;
}






//---------------------------------------------------------------
//---------------------------------------------------------------
//---------------------------------------------------------------





//-------------------------------------------------------------------
// RA
DWORD WINAPI CoreThread(LPVOID lpData)
{
	LPCOREDATA lpCoreData = (LPCOREDATA)lpData;
	HWND hWnd = lpCoreData->hWnd;
	UINT uDeviceID = lpCoreData->uDeviceID;

	DWORD dwPrepareHdr;  // waveInPrepareHeader() wb_̔ԍ

	// Gp
	DWORD i,i2,dwWaitTime; 
	char szErrStr[CHR_BUF];
	MMRESULT mmResult,mmResult2; // G[`FbNp
	DWORD dwRet = 1;
	
	// Jn
	DwCoreStatus = ID_PREPARE;
	HdWaveIn = NULL;
	HdHeap = NULL;
	szErrStr[0] = '\0';

	// q[v쐬
	HdHeap = HeapCreate(HEAP_NO_SERIALIZE,
		sizeof(BYTE)*DwCoreWaveBlockByte*(DwWaveHdrNumber+1)+1024,
		0);
	if(HdHeap == NULL)
	{
		wsprintf(szErrStr,"q[v̍쐬Ɏs܂B\nobt@TCYύXĉB");
		goto L_ERR;
	}
	
	Sleep(50);

	// wave wb_Ƀobt@Zbg
	if(!SetHeapWaveHdr(
		hWnd,
		HdHeap,
		NULL,
		WaveHdr,
		DwWaveHdrNumber,
		DwCoreWaveBlockByte))
	{
		wsprintf(szErrStr,"̊蓖ĂɎs܂Bobt@̃TCY␔ύXĉB");
		goto L_ERR;
	}

	// foCXI[v
	mmResult = waveInOpen(&HdWaveIn, uDeviceID,&WaveFmtCore,(DWORD)MyWaveInProc,0,CALLBACK_FUNCTION);
	
	if(mmResult == WAVERR_BADFORMAT)
	{
		wsprintf(szErrStr,	
			"̃foCX͎w肵ݒ([gArbgA`l)\nł̘^ɑΉĂ܂BݒύXĉB");
		goto L_ERR;
	}
	
	if(mmResult != MMSYSERR_NOERROR)
	{
		wsprintf(szErrStr,	
			"TEhfoCX̃I[vɎs܂(%d)\ñvZXfoCXgpĂ\܂B",mmResult);
		goto L_ERR;
	} 
	
	// I[v܂Œ~
	i=0; dwWaitTime = 200;
	while(DwCoreStatus != ID_OPENWAVE && i < dwWaitTime)
	{
		Sleep(10);
		i++; 
	}
	if(i >= dwWaitTime)
	{
		wsprintf(szErrStr,	
			"TEhfoCX̃I[vɎs܂",mmResult);
		goto L_ERR;
	} 

	// obt@̃Zbg
	for(i=0;i<WAVEHDR_SETNUM;i++)
	{
		mmResult = waveInPrepareHeader(HdWaveIn,&WaveHdr[i],sizeof(WAVEHDR));
		i2=0; dwWaitTime = 100;
		while(WaveHdr[i].dwFlags != WHDR_PREPARED  && i2 < dwWaitTime)
		{
			Sleep(1);
			i2++;
		}
		mmResult2 = waveInAddBuffer(HdWaveIn,&WaveHdr[i],sizeof(WAVEHDR));
		if(mmResult != MMSYSERR_NOERROR || mmResult2 != MMSYSERR_NOERROR || i2 >= dwWaitTime)
		{
			wsprintf(szErrStr,	
				"obt@̃ZbgɎs܂(%d,%d,%d)\n\n^Jno܂B[gobt@̐ATCYύXĉ"
				,i,mmResult,mmResult2);
			goto L_ERR;
		} 
	}

	DwReadWaveHdr = 0;	
	dwPrepareHdr = WAVEHDR_SETNUM-1;
	DwCurWaveHdr = 0;  
	
	// ^Jn
	mmResult = waveInStart(HdWaveIn);
	if(mmResult != MMSYSERR_NOERROR)
	{ 
		wsprintf(szErrStr, "^Jnł܂(%d)",mmResult);
		goto L_ERR;
	}

	// --------------------
	// [vJn
	DwCoreStatus = ID_LOOP;
	while(DwCoreStatus != ID_EXITLOOP)
	{
		if(WaitForSingleObject(HcoreLock,10) != WAIT_TIMEOUT)
		{
			// ^̃wb_^ɂȂꍇ
			while(WaveHdr[DwReadWaveHdr].dwFlags & WHDR_DONE)
			{
				// Unprepare 
				mmResult = waveInUnprepareHeader(HdWaveIn,&WaveHdr[DwReadWaveHdr],sizeof(WAVEHDR));
				if(mmResult != MMSYSERR_NOERROR)
				{
					wsprintf(szErrStr,	
						"obt@̊JɎs܂([recording]%d,%d,%d,%d)\n\n^ĊJł܂B"
						,mmResult,DwReadWaveHdr,dwPrepareHdr,DwCurWaveHdr);
					goto L_ERR;
				} 
				DwReadWaveHdr = (DwReadWaveHdr+1)&(DwWaveHdrNumber-1);
				
				//  obt@Zbg
				dwPrepareHdr = (dwPrepareHdr+1)&(DwWaveHdrNumber-1);
		
				// 
				if(DwCurWaveHdr == dwPrepareHdr)  
					DwCurWaveHdr = (DwCurWaveHdr+1)&(DwWaveHdrNumber-1);
		
				// Prepare
				memset(WaveHdr[dwPrepareHdr].lpData, 0,DwCoreWaveBlockByte);
				WaveHdr[dwPrepareHdr].dwBytesRecorded = 0;
				WaveHdr[dwPrepareHdr].dwFlags = 0;
				mmResult = waveInPrepareHeader(HdWaveIn,&WaveHdr[dwPrepareHdr],sizeof(WAVEHDR));
				i2=0; dwWaitTime = 100;
				while(WaveHdr[dwPrepareHdr].dwFlags != WHDR_PREPARED  && i2 < dwWaitTime)
				{
					Sleep(1);
					i2++;
				}
				mmResult2 = waveInAddBuffer(HdWaveIn,&WaveHdr[dwPrepareHdr],sizeof(WAVEHDR));
				if(mmResult != MMSYSERR_NOERROR || mmResult2 != MMSYSERR_NOERROR || i2 >= dwWaitTime)
				{
					wsprintf(szErrStr,	
						"obt@̃ZbgɎs܂([recording]%d,%d,%d,%d,%d)\n\n^ĊJł܂B"
						,mmResult,mmResult2,DwReadWaveHdr,dwPrepareHdr,DwCurWaveHdr);
					goto L_ERR;
				}
			}

			// ݃wb_XV
			if(DwCurWaveHdrLock == 0 && 
				DwCurWaveHdr != DwReadWaveHdr)
			{
				WaveHdr[DwCurWaveHdr].dwFlags = 0;
				DwCurWaveHdrLock = DwCurWaveHdrLockMask;
				DwCurWaveHdr = (DwCurWaveHdr+1)&(DwWaveHdrNumber-1);
			}

			ReleaseSemaphore(HcoreLock,1,NULL);	
		}

		Sleep(20);
	}
	// [vI
	// --------------------
	
	dwRet = 0;

L_ERR:

	if(HdWaveIn != NULL)
	{
		// ^~
		mmResult = waveInReset(HdWaveIn);
		if(mmResult != MMSYSERR_NOERROR) 
		{
			wsprintf(szErrStr, "^~ł܂([close]%d)\n\nRs[^ċNĉ",mmResult);
			goto L_ERR2;
		}
		
		Sleep(20); 
		
		// obt@̌n
		// YFREE()Ăł̊JĂȂ 
		for(i=0;i<DwWaveHdrNumber;i++)
			waveInUnprepareHeader(HdWaveIn,&WaveHdr[i],sizeof(WAVEHDR));
		
		// foCXN[Y
		mmResult = waveInClose(HdWaveIn);
		if(mmResult != MMSYSERR_NOERROR) 
		{
			wsprintf(szErrStr, "^foCX̃N[YɎs܂([close]%d)\n\nRs[^ċNĉ",mmResult);
			goto L_ERR2;
		}
		else
		{
			// N[Y܂Œ~
			i=0; dwWaitTime = 200;
			while(DwCoreStatus != ID_CLOSEWAVE && i < dwWaitTime)
			{
				Sleep(10);
				i++;
			}
		}
	}
	
L_ERR2:
	HdWaveIn = NULL;

	// q[v폜
	if(HdHeap)
	{
		if(HeapDestroy(HdHeap) == 0)
		{
			MyMessageBox(hWnd, "̊JɎs܂\n\nbNċNĂ","LOCK ON", MB_OK|MB_ICONERROR);
		}
	}
	HdHeap = NULL;
	
	// Xbh~
	HdCoreThread = NULL;

	// G[\
	if(strlen(szErrStr)) MyMessageBox(hWnd,szErrStr,"Error", MB_OK|MB_ICONERROR);

	return dwRet;
}





//-------------------------------------------------------------------
// ^Xbh
DWORD WINAPI RecWaveThread(LPVOID dwThreadID)
{
	DWORD dwThread = (DWORD)dwThreadID;
	HWND hWnd = RecThreadData[dwThread].hWnd;
	UINT uDeviceID = RecThreadData[dwThread].uDeviceID;
	LPSTR lpszFileName = RecThreadData[dwThread].szFileName; // t@C
	WAVEFORMATEX waveFmt = RecThreadData[dwThread].waveFmt; // wave tH[}bg
	DWORD dwWaveHdrNumber = RecThreadData[dwThread].wWaveHdrNumber; // obt@̐
	DWORD dwWaveBlockByte = RecThreadData[dwThread].dwWaveBlockByte; //obt@̃oCg
	BOOL bDiskCache = RecThreadData[dwThread].bDiskCache; // fBXNLbVgǂ
	BOOL bMarginCheck =  RecThreadData[dwThread].bMarginCheck; // }[W̃`FbN邩
	WORD wSaveMode =  RecThreadData[dwThread].wSaveMode; // ۑ
	BOOL bOpenConsole = RecThreadData[dwThread].bOpenConsole; // R\[J
	DWORD dwPipeSize = RecThreadData[dwThread].dwPipeSize; // pCṽobt@TCY
	WORD wForceMono = RecThreadData[dwThread].wForceMono; // m[h
	BOOL bHeaderOffPipe = RecThreadData[dwThread].bHeaderOffPipe; // pCv[h wave wb_o͂Ȃ
	DWORD dwAftComWait = RecThreadData[dwThread].dwAftComWait;  // R}hs҂
	DWORD dwWimNum = RecThreadData[dwThread].dwWimNum; // MM_WIM_DATA ŕԂԍ
	DWORD dwRecTime = RecThreadData[dwThread].dwRecTime;
	BOOL bClose = RecThreadData[dwThread].bClose;

	char szPipeCom[CHR_BUF]; // pCṽR}hCɓn
	char szAftCom[CHR_BUF]; // ^sR}h
	
	LONGLONG n64FileSize; // ^f[^TCY
	LONGLONG n64WaveDataSize; // o͍ς݃f[^TCY
	DWORD dwWriteByte; // obt@ւ̏݃TCY
	DWORD dwTime; // ^ԌvZp(msec)
	double dPeak[WAVEHDR_MAXBUF][2];  // e WPARAM œnf[^(ős[Nl)
	CHAR szStr[CHR_BUF],szErrStr[CHR_BUF]; // G[bZ[W
	UINT uRetLparam = WIMCLOSE_STOP;// MM_WIM_CLOSE Őeɓn LPARAMB RPARAM ̓Xbhԍ
	WIMDAT wimDat;

	// g WAVE wb_p
	BOOL bUseExtChunk;

	// pCvp
	PIPEHANDLE pipeHandle;
	
	// }[W̃`FbNp
	ULONGLONG ullFreeHddSize;
	DWORD dwFreeHddSize;
	WORD wCheckTiming = 0;  // `FbN^C~O
	
	// mp
	WAVEFORMATEX waveWriteFmt;
	LONGLONG n64WriteFileSize;

	// Gp
	DWORD i; 
	DWORD dwExitCode;
	DWORD dwFoo,dwWaitTime;

	// ɏԂɓȂ悤ɃbN
	if(WaitForSingleObject(HrecLock,10000) == WAIT_TIMEOUT)
	{
		wsprintf(szErrStr,"̘^Xbh̉܂");
		goto L_ERR;
	}

	// Jn
	RecThreadData[dwThread].dwRecStatus = ID_PREPARE;
	HdFile[dwThread] = NULL;
	ProcessInfo[dwThread].hProcess = NULL;
	n64WaveDataSize = 0;
	ZeroMemory(dPeak,sizeof(double)*2*WAVEHDR_MAXBUF);
	wimDat.dwWimNum = dwWimNum;
	szErrStr[0] = '\0';
	LpForceMonoData[dwThread] = NULL;

	strcpy(szPipeCom,RecThreadData[dwThread].szPipeCom);
	strcpy(szAftCom,RecThreadData[dwThread].szAftCom);
	GetLocalTime(&(RecThreadData[dwThread].sysTimeStart));
	RecThreadData[dwThread].dwTime = 0;

	// HDD [h
	if(wSaveMode == SAVE_HDD)
	{  
		// t@CJ
		if(bDiskCache) // LbVgp
			HdFile[dwThread] = CreateFile(lpszFileName,GENERIC_WRITE, 
			0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); 
		else  // ڃfBXNɏ
			HdFile[dwThread] = CreateFile(lpszFileName,GENERIC_WRITE, 
			0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_WRITE_THROUGH, NULL); 
		
		if(HdFile[dwThread] == INVALID_HANDLE_VALUE) 
		{  
			wsprintf(szErrStr,"t@CI[vł܂B\ñvZXt@CJĂ\܂B");
			HdFile[dwThread] = NULL;
			goto L_ERR;
		}
	}
	else if(wSaveMode == SAVE_PIPE) // PIPE [h
	{
		// ẽnh擾
		pipeHandle.hParent = GetCurrentProcess();
		
		if(!ExecPipeCommand(NULL,
			szPipeCom,
			&ProcessInfo[dwThread],&pipeHandle,dwPipeSize,bOpenConsole,szStr))
		{
			wsprintf(szErrStr,"%s\n\npCv̐ݒmFĉB",szStr);
			goto L_ERR;
		}
		
		HdFile[dwThread] = pipeHandle.hPipeP2Cin; // pCṽnhn
		
		Sleep(100);
		
		// R\[ X {^𖳌ɂ
		if(bOpenConsole)
			DeleteMenu(GetSystemMenu(GetConsoleWindowHandle(),FALSE),SC_CLOSE, MF_BYCOMMAND);
		
		Sleep(100);
	
		// qvZXNĂ邩`FbN
		GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
		if(dwExitCode != STILL_ACTIVE){
			
			Sleep(2000);
			
			GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
			if(dwExitCode != STILL_ACTIVE)
			{
				wsprintf(szErrStr,"qvZX~Ă܂(%d)\n\n^Jnł܂B",dwExitCode);
				goto L_ERR;
			}
		}
	}

	// tH[hɎĂ
	SetForegroundWindow(hWnd);
	
	// RAĂă[vԂłȂ͑҂
	i=0; dwWaitTime = 500;
	while(HdCoreThread != NULL && DwCoreStatus != ID_LOOP && i < dwWaitTime)
	{
		Sleep(10);
		i++;
	}
	if(i >= dwWaitTime)
	{
		wsprintf(szErrStr,"RẢ܂");
		goto L_ERR;
	}

	// ^RAN
	COREDATA coreData;
	DWORD dwCoreID;

	// }XNZbg
	if(WaitForSingleObject(HcoreLock,5000) == WAIT_TIMEOUT)
	{
		wsprintf(szErrStr,"RẢ܂");
		goto L_ERR;
	}
	DwCurWaveHdrLockMask |= (1 << dwThread);
	DwCurWaveHdrLock |= (1 << dwThread);
	ReleaseSemaphore(HcoreLock,1,NULL);		
	
	if(HdCoreThread == NULL)
	{
		coreData.hWnd = hWnd;
		coreData.uDeviceID = uDeviceID;
		DwCoreWaveBlockByte = dwWaveBlockByte; 
		WaveFmtCore = waveFmt; 
		DwWaveHdrNumber = dwWaveHdrNumber;
		HdCoreThread = CreateThread(NULL,0,
			(LPTHREAD_START_ROUTINE)CoreThread,
			(LPVOID)&coreData,
			0,(LPDWORD)&dwCoreID);
		if(HdCoreThread == NULL)
		{
			wsprintf(szErrStr,"^RA̋NɎs܂B","Error", MB_OK|MB_ICONERROR);
			goto L_ERR;
		}
		
		// I[v܂Œ~
		i=0; dwWaitTime = 500;
		while(DwCoreStatus != ID_LOOP && i < dwWaitTime)
		{
			Sleep(10);
			i++; 
			if(HdCoreThread == NULL) // RA~
				goto L_ERR;
		}
		if(i >= dwWaitTime)
		{
			wsprintf(szErrStr,"^RẢ܂");
			goto L_ERR;
		}		
	}

	// bN
	ReleaseSemaphore(HrecLock,1,NULL);		

	// tH[}bgăZbg
	waveFmt = WaveFmtCore;
	RecThreadData[dwThread].waveFmt = waveFmt;
	if(waveFmt.nChannels != 2) wForceMono = FORCE_MONO_OFF;
	RecThreadData[dwThread].wForceMono = wForceMono;
	dwWaveBlockByte = DwCoreWaveBlockByte;
	RecThreadData[dwThread].dwWaveBlockByte = dwWaveBlockByte;

	SendMessage(hWnd,WM_STARTREC,0,(LPARAM)&waveFmt); // eɎۂ wave format M
	
	if(wSaveMode != SAVE_TEST)
	{
		if(wForceMono != FORCE_MONO_OFF)
			LpForceMonoData[dwThread] =(LPBYTE)GlobalAlloc(GPTR,sizeof(BYTE)*dwWaveBlockByte);

		GetDataSize(waveFmt,dwRecTime,&n64FileSize);
		
		wsprintf(szStr,"^Jn[%d]: %s",dwWimNum+1,lpszFileName);
		WriteLog(szStr);	
		
		// WAVE wb_
		waveWriteFmt = waveFmt;
		n64WriteFileSize = n64FileSize;
		if(wForceMono != FORCE_MONO_OFF) 	// m
		{
			SetWaveFmt(&waveWriteFmt,waveFmt.nChannels/2,waveFmt.nSamplesPerSec,waveFmt.wBitsPerSample,waveFmt.wFormatTag);
			n64WriteFileSize /= 2;
		}	
		
		// wb_TCYvZ
		bUseExtChunk = FALSE;
		if(n64WriteFileSize >= 0xFFFFFFFF-44) bUseExtChunk = TRUE;
		
		// pCv̏ꍇ̓wb_
		if(wSaveMode == SAVE_PIPE && !bHeaderOffPipe)
		{
			bUseExtChunk = FALSE; // pCv̎͊gwb_gȂ
			WriteWaveHeader(HdFile[dwThread],&waveWriteFmt,n64WriteFileSize,bUseExtChunk);
		}
		else // t@C|C^Zbg	
		{
			LARGE_INTEGER LI; 
			LI.QuadPart = WAVEHDRSIZE(bUseExtChunk);
			SetFilePointer(HdFile[dwThread],LI.LowPart, &LI.HighPart,FILE_BEGIN);
		}
	}
	
	// --------------------
	// [vJn

	// ҋ@^̏ꍇɃ|[Y
	if(!RecThreadData[dwThread].bPauseRec) RecThreadData[dwThread].dwRecStatus = ID_LOOP;
	else RecThreadData[dwThread].dwRecStatus = ID_PAUSE;

	while(RecThreadData[dwThread].dwRecStatus != ID_EXITLOOP)
	{
		// f[^
		if(RecThreadData[dwThread].dwRecStatus == ID_LOOP && 
			(WaveHdr[DwCurWaveHdr].dwFlags & WHDR_DONE))
		{
			// RA~܂ĂȂ`FbN
			if(HdCoreThread == NULL || DwCoreStatus != ID_LOOP)
			{
				wsprintf(szErrStr,"RA~Ă܂");
				goto L_ERR;
			}

			// pCv؂ĂȂ`FbN
			if(wSaveMode == SAVE_PIPE)
			{
				GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
				if(dwExitCode != STILL_ACTIVE){
					wsprintf(szErrStr,"pCvؒf܂(%d)",dwExitCode);
					goto L_ERR;
				}
			}
			
			// 
			if(wSaveMode != SAVE_TEST)
			{
				
				dwWriteByte = 
					n64WaveDataSize + WaveHdr[DwCurWaveHdr].dwBytesRecorded >= n64FileSize ? 
					(DWORD)(n64FileSize-n64WaveDataSize) 
					: WaveHdr[DwCurWaveHdr].dwBytesRecorded;
				
				if(!WriteRecWaveData(HdFile[dwThread]
					,(LPBYTE)(WaveHdr[DwCurWaveHdr].lpData), 
					dwWriteByte,
					waveFmt.wBitsPerSample,
					wForceMono,
					LpForceMonoData[dwThread],
					NULL))
				{
					// ݎs
					RecThreadData[dwThread].dwRecStatus = ID_EXITLOOP; // [v~
					wsprintf(szErrStr,"f[^̕ۑɎs܂BfBXN̋eʂȂ\܂");
					goto L_ERR;
				}
				else n64WaveDataSize += dwWriteByte;
			}
			else n64WaveDataSize += WaveHdr[DwCurWaveHdr].dwBytesRecorded;
			
			// eɓnf[^Zbg(s[NlvZ)
			WaveLevelMaxPeak(dPeak[DwCurWaveHdr],
				(LPBYTE)WaveHdr[DwCurWaveHdr].lpData,WaveHdr[DwCurWaveHdr].dwBytesRecorded,
				waveFmt);
			
			// oߎԌvZ(msec)
			dwTime = (DWORD)(n64WaveDataSize*1000/waveFmt.nAvgBytesPerSec);
			
			// e MM_WIM_DATA M
			wimDat.dwTime = dwTime;
			RecThreadData[dwThread].dwTime = dwTime;
			SendMessage(hWnd,MM_WIM_DATA,(WPARAM)dPeak[DwCurWaveHdr],(LPARAM)(&wimDat));
			
			// bN
			dwFoo = DwCurWaveHdr;
			if(WaitForSingleObject(HcoreLock,5000) == WAIT_TIMEOUT)
			{
				wsprintf(szErrStr,"RẢ܂");
				goto L_ERR;
			}
			DwCurWaveHdrLock &= ~(1 << dwThread);
			ReleaseSemaphore(HcoreLock,1,NULL);				
			while(DwCurWaveHdr == dwFoo 
				&& RecThreadData[dwThread].dwRecStatus != ID_EXITLOOP){
				Sleep(10);
			}
			
			// HDD }[W`FbN
			if(wSaveMode != SAVE_TEST && bMarginCheck)
			{
				//  4 Ɉ`FbN
				wCheckTiming = (wCheckTiming+1)&3;
				
				// `FbN
				if(!wCheckTiming)
				{
					GetFreeHddSpace64(&ullFreeHddSize,lpszFileName);
					dwFreeHddSize = (DWORD)(ullFreeHddSize/1024/1024);
					
					// ~
					if(dwFreeHddSize <= HDDMARGINSIZE/1024/1024)
					{
						RecThreadData[dwThread].dwRecStatus = ID_EXITLOOP;
						uRetLparam = WIMCLOSE_MRG;
					}
				}
			}
			
			// w肵TCYɂȂ`FbN
			if(wSaveMode != SAVE_TEST)
			{
				if(n64WaveDataSize >= n64FileSize) {
					RecThreadData[dwThread].dwRecStatus = ID_EXITLOOP;
					uRetLparam = WIMCLOSE_DONE;
				}
			}
		}
		else Sleep(20);
	}
	// [vI
	// --------------------
	
	// RA~
	if(WaitForSingleObject(HcoreLock,5000) == WAIT_TIMEOUT)
	{
		wsprintf(szErrStr,"RẢ܂");
		goto L_ERR;
	}
	DwCurWaveHdrLockMask &= ~(1 << dwThread);
	DwCurWaveHdrLock &= ~(1 << dwThread);
	if(DwCurWaveHdrLockMask == 0)
	{
		DwCoreStatus = ID_EXITLOOP;
		// RA~܂Œ~
		i = 0; dwWaitTime = 500;
		while(HdCoreThread != NULL)		
		{
			Sleep(10);
			i++;
		}
		if(i >= dwWaitTime)
			MyMessageBox(hWnd,"RẢ܂B\n\nShift Ȃ~{^ċ~ĂB","LOCK ON", MB_OK|MB_ICONWARNING);
	}
	ReleaseSemaphore(HcoreLock,1,NULL);	
		
	if(wSaveMode != SAVE_TEST)
	{
		// wb_o(HDD ^)
		if(wSaveMode == SAVE_HDD)
		{
			n64WriteFileSize = n64WaveDataSize;
			if(wForceMono != FORCE_MONO_OFF) n64WriteFileSize /= 2;	// m
			WriteWaveHeader(HdFile[dwThread],&waveWriteFmt,n64WriteFileSize,bUseExtChunk);
		}
		
		// t@CN[YApCv̏ꍇ EOF 
		if(HdFile[dwThread] != NULL) CloseHandle(HdFile[dwThread]);	 	
		HdFile[dwThread] = NULL;
		
		// qvZX~܂ŃXgbv
		// 10 bĂIĂȂ~
		if(wSaveMode == SAVE_PIPE && ProcessInfo[dwThread].hProcess != NULL)
		{ 
			WaitForSingleObject(ProcessInfo[dwThread].hProcess,10*1000); // 10 b҂
			GetExitCodeProcess(ProcessInfo[dwThread].hProcess,&dwExitCode);
			if(dwExitCode == STILL_ACTIVE)
			{
				wsprintf(szErrStr,"vZX~ł܂łB~܂");
				goto L_ERR;
			}
			ProcessInfo[dwThread].hProcess = NULL;
			Sleep(100);
			
			// R\[
			if(wSaveMode == SAVE_PIPE && bOpenConsole) MyFreeConsole();
		}
		
		Sleep(10);
		
		// XVԂ^JnԂɂ
		if(RecThreadData[dwThread].bAdjustWriteTime)
		{
			FILETIME ftLocal,ftUtc;
			HANDLE hTimeFile;
			hTimeFile = CreateFile(lpszFileName,GENERIC_WRITE, 
				0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL); 
			
			if(hTimeFile)
			{
				// ԌvZ (systemtime -> utc -> LARGE_INTEGER)
				SystemTimeToFileTime(&(RecThreadData[dwThread].sysTimeStart),&ftLocal);
				LocalFileTimeToFileTime(&ftLocal,&ftUtc);
				SetFileTime(hTimeFile,&ftUtc,&ftUtc,&ftUtc);
				CloseHandle(hTimeFile);
			}
		}
		
		// Oo
		wsprintf(szStr,"^[%d]",dwWimNum+1);
		WriteLog(szStr);
	}

	// Ɨ̈̃J
	if(LpForceMonoData[dwThread]) GlobalFree(LpForceMonoData[dwThread]);

	// ^R}hs
	if(strlen(szAftCom))
	{
		if(RecThreadData[dwThread].dwMouseMoveTime)
		{
			dwFoo = GetMouseMoveTime();
			if(dwFoo <= RecThreadData[dwThread].dwMouseMoveTime)
			{
				wsprintf(szStr,"s()[%d]: sLZ(%d sec)",dwWimNum+1,dwFoo);
				WriteLog(szStr);
				goto L_CANCELCOMMAND;
			}
		}

		if(dwAftComWait)
		{
			wsprintf(szStr,"%s\n\ns܂BOK ƒɎs܂",szAftCom);
			if(MyMessageBoxEx(hWnd,szStr,
				"LOCK ON", MB_OKCANCEL|MB_ICONINFORMATION,dwAftComWait,TRUE,TRUE) == IDCANCEL){
				goto L_CANCELCOMMAND;
			}
		}
		
		wsprintf(szStr,"s()[%d]: %s",dwWimNum+1,szAftCom);
		WriteLog(szStr);
		
		if(!ExecCommand(szAftCom,NULL,FALSE)){
			wsprintf(szStr,"%s\n\nR}h̎sɎs܂BݒmFĉ",szAftCom);
			MyMessageBox(hWnd,szStr,"Error", MB_OK|MB_ICONERROR);
		}
	}

L_CANCELCOMMAND:

	// Xbh~
	HdRecThread[dwThread] = NULL;

	// e MM_WIM_CLOSE 𑗐M
	SendMessage(hWnd,MM_WIM_CLOSE,(WPARAM)dwThread,(LPARAM)uRetLparam);


	// XP ̏ꍇʂ̍ĕ`悪܂Ȃ̂ōĕ`悵ƂB
	Sleep(100);
	InvalidateRect(hWnd,NULL,FALSE);

	Sleep(1000);

	// ^I
	if(bClose) SendMessage(hWnd,WM_ENDLOCKON,0,0);

	// I
	return 0;
	
	//---------------------------------
	// G[
L_ERR:
	
	ReleaseSemaphore(HrecLock,1,NULL);		

	// ^~
	if(WaitForSingleObject(HcoreLock,5000) == WAIT_TIMEOUT)
	{
		wsprintf(szErrStr,"RẢ܂");
		goto L_ERR;
	}
	DwCurWaveHdrLockMask &= ~(1 << dwThread);
	DwCurWaveHdrLock &= ~(1 << dwThread);
	if(DwCurWaveHdrLockMask == 0)
	{
		DwCoreStatus = ID_EXITLOOP;
		// RA~܂Œ~
		i = 0; dwWaitTime = 500;
		while(HdCoreThread != NULL)		
		{
			Sleep(10);
			i++;
		}
		if(i >= dwWaitTime)
			MyMessageBox(hWnd,"RẢ܂B\n\nShift Ȃ~{^ċ~ĂB","LOCK ON", MB_OK|MB_ICONWARNING);
	}
	ReleaseSemaphore(HcoreLock,1,NULL);		

	// ~
	ExitRecError(hWnd,dwThread); 

	// tH[hɎĂ
	SetForegroundWindow(hWnd);

	// G[bZ[W
	if(strlen(szErrStr))
	{
		wsprintf(szStr,"G[[%d]:[Xbh%d]\n\n%s",dwWimNum+1,dwThread+1,szErrStr);
		MyMessageBox(hWnd,szStr,"LOCK ON", MB_OK|MB_ICONERROR);
	}

	// R\[
	if(wSaveMode == SAVE_PIPE && bOpenConsole) MyFreeConsole();
	
	// XP ̏ꍇʂ̍ĕ`悪܂Ȃ̂ōĕ`悵ƂB
	Sleep(100);
	InvalidateRect(hWnd,NULL,FALSE);

	// Oo
	wsprintf(szStr,"^s[%d]",dwWimNum+1);
	WriteLog(szStr);

	// Xbh~
	HdRecThread[dwThread] = NULL;
	RecThreadData[dwThread].dwRecStatus = ID_CLOSEWAVE;

	// e MM_WIM_CLOSE 𑗐M
	SendMessage(hWnd,MM_WIM_CLOSE,(WPARAM)dwThread,WIMCLOSE_ERR);

	Sleep(1000);

	// ^I
	if(bClose) SendMessage(hWnd,WM_ENDLOCKON,0,0);

	return 1;
}

//EOF