// WaitableTimer ֌W
//
// (c) 2002 tokai@main.eng.hokudai.ac.jp
//
// {vÔׂāA܂͈ꕔ GPL ɏ]čĔЕz܂͕ύX
// Ƃł܂BڍׂɂĂGNU ʌLgpǂ݂B
//
#include <windows.h>
#include "common.h"

//#define WTIMER_DEBUG   // ^C}[̃fobOp

int MyMessageBox(HWND,LPSTR,LPSTR,UINT);
void WriteLog(char* szLog);

// Xbhɓnf[^^
typedef struct
{
	HWND hWnd;
	SYSTEMTIME stTime;
	DWORD dwOffsetSec;
}TIMERDATA,*LPTIMERDATA;


typedef VOID (APIENTRY *PTIMERAPCROUTINE)(LPVOID lpArgToCompletionRoutine,DWORD dwTimerLowValue,DWORD dwTimerHighValue);
typedef HANDLE (WINAPI *CRWTIMER)(LPSECURITY_ATTRIBUTES,BOOL,LPCTSTR);
typedef BOOL (WINAPI *CLWTIMER)(HANDLE);
typedef BOOL (WINAPI *STWTIMER)(HANDLE,const LARGE_INTEGER*,LONG,PTIMERAPCROUTINE,LPVOID,BOOL);
typedef EXECUTION_STATE (WINAPI *STESAT)(EXECUTION_STATE);

#define WTSTAT_PREPARE	1
#define WTSTAT_ON		2
#define WTSTAT_OFF		0

// O[o
HANDLE HdTimer;
LARGE_INTEGER Li_Timer;
CRWTIMER LpCreateWaitableTimer = NULL;
CLWTIMER LpCancelWaitableTimer = NULL;
STWTIMER LpSetWaitableTimer = NULL;
STESAT LpSetThreadExecutionState = NULL;
HANDLE HdWaitableTimerThread = NULL; // Xbh̃nh
DWORD DwWaitableTimerStatus = WTSTAT_OFF; // Xbh̏



//-----------------------------------------------------
// WaitableTimer g邩
BOOL CanUseWaitableTimer(){

	if(LpCreateWaitableTimer) return TRUE;

	return FALSE;
}


//-----------------------------------------------------
// 
BOOL InitWaitableTimer(){

	HMODULE hKernel32;

	HdTimer = NULL;
	HdWaitableTimerThread = NULL;
	DwWaitableTimerStatus = WTSTAT_OFF;

	if(!LpCreateWaitableTimer){
		if(hKernel32 = GetModuleHandle("kernel32.dll")){
			LpCreateWaitableTimer = (CRWTIMER)GetProcAddress(hKernel32,"CreateWaitableTimerA");
			if(!LpCreateWaitableTimer) goto L_ERR;
			LpCancelWaitableTimer = (CLWTIMER)GetProcAddress(hKernel32,"CancelWaitableTimer");
			if(!LpCancelWaitableTimer) goto L_ERR;
			LpSetWaitableTimer = (STWTIMER)GetProcAddress(hKernel32,"SetWaitableTimer");
			if(!LpSetWaitableTimer) goto L_ERR;
			LpSetThreadExecutionState = (STESAT)GetProcAddress(hKernel32,"SetThreadExecutionState");
		}
		else goto L_ERR;
	}

	return TRUE;

L_ERR:

	LpCreateWaitableTimer = NULL;
	LpCancelWaitableTimer = NULL;
	LpSetWaitableTimer = NULL;

	return FALSE;
}


//-----------------------------------------------------
// Zbg
VOID ResetWaitableTimer(HWND hWnd){

	DWORD i;

#ifdef WTIMER_DEBUG
	if(HdWaitableTimerThread)
		MyMessageBox(hWnd,"ċN^C}[XbhZbgĂ܂","LOCK ON", MB_OK);
	else 
		MyMessageBox(hWnd,"ċN^C}[XbhZbgĂ܂","LOCK ON", MB_OK);
#endif
	
	// Xbh~܂Œ~
	DwWaitableTimerStatus = WTSTAT_OFF;
	i=0;
	while(HdWaitableTimerThread && i<100){
		Sleep(50);
		i++;
	}
	if(i == 100){
		MyMessageBox(hWnd,
			"ċN^C}[Xbh~ł܂łBLOCK ON ċNĂB",
			"Error", MB_OK|MB_ICONERROR);
		
		if(HdTimer){
			if(LpCancelWaitableTimer) LpCancelWaitableTimer(HdTimer); 
			CloseHandle(HdTimer);
		}
		if(HdWaitableTimerThread) TerminateThread(HdWaitableTimerThread,1);
		HdTimer = NULL;	
		HdWaitableTimerThread = NULL;
	}

}


//-----------------------------------------------------
// ݒ莞ԂԂ֐
BOOL InfoWaitableTimer(LPSYSTEMTIME lpstTime){

	FILETIME ftLocal,ftUtc;

	if(!HdTimer) return FALSE;

	memcpy(&ftUtc,&Li_Timer,sizeof(FILETIME));
	FileTimeToLocalFileTime(&ftUtc,&ftLocal);
	FileTimeToSystemTime(&ftLocal,lpstTime);

	return TRUE;
}


//-------------------------------------------
// X[vȂ悤ɎIɌĂё 
EXECUTION_STATE MySetThreadExecutionState(){

	if(LpSetThreadExecutionState) 
		return LpSetThreadExecutionState(ES_SYSTEM_REQUIRED);

  return NULL;
}



//-------------------------------------------
// ċN^C}[NɌĂяoR[obN֐
VOID CALLBACK MyTimerAPCProc(LPVOID lpArg,
							 DWORD dwLow,
							 DWORD dwHigh
							 ){
	char szStr[CHR_BUF];

	MySetThreadExecutionState();
	
	wsprintf(szStr,"ċN^C}[ ON");
	WriteLog(szStr);
	
#ifdef WTIMER_DEBUG
	MyMessageBox(*((HWND*)lpArg),szStr,"LOCK ON",MB_OK);
#endif
}



//------------------------------------------
// WaitableTimer NXbh
BOOL WINAPI SetWaitableTimerThread(LPVOID lpTimerData){

	HWND hParent = ((LPTIMERDATA)lpTimerData)->hWnd;
	SYSTEMTIME stTime = ((LPTIMERDATA)lpTimerData)->stTime;
	DWORD dwOffsetSec = ((LPTIMERDATA)lpTimerData)->dwOffsetSec;

	FILETIME ftLocal,ftUtc;
#ifdef WTIMER_DEBUG
	SYSTEMTIME stCurrent,sysTime;
	char szStr[CHR_BUF];
#endif
	LARGE_INTEGER liDueTime;
	CHAR szTimer[CHR_BUF];
	DWORD i;
	BOOL bRet = FALSE;

	DwWaitableTimerStatus = WTSTAT_PREPARE;

	if(!LpCreateWaitableTimer) goto L_ERR;
	if(!LpSetWaitableTimer) goto L_ERR;
	if(HdTimer){
		if(LpCancelWaitableTimer) LpCancelWaitableTimer(HdTimer); 
		CloseHandle(HdTimer);
		HdTimer = NULL;
	}

	// ̃vZX̃^C}[ƃ^C}[ signal ԂɂȂ炸
	// ^C}[~ꍇ̂ŒP̃^C}[Kv
	wsprintf(szTimer,"LKMWT%d%d",GetCurrentProcessId(),GetTickCount());

#ifdef WTIMER_DEBUG
	MyMessageBox(hParent,szTimer,"^C}[",MB_OK);
#endif

	// ^C}[쐬
	if(!(HdTimer = LpCreateWaitableTimer(NULL,TRUE,szTimer))) goto L_ERR;

	// ԌvZ (systemtime -> utc -> LARGE_INTEGER)
	SystemTimeToFileTime(&stTime,&ftLocal);
	LocalFileTimeToFileTime(&ftLocal,&ftUtc);
	memcpy(&liDueTime,&ftUtc,sizeof(FILETIME));

#ifdef WTIMER_DEBUG
	wsprintf(szStr,"%x %x <- %x %x",
		liDueTime.HighPart,liDueTime.LowPart,
		ftUtc.dwHighDateTime,ftUtc.dwLowDateTime);
	MyMessageBox(hParent,szStr,"TCY1",MB_OK);
#endif

	// ItZbgԂ߂
	for(i=0;i<dwOffsetSec;i++) liDueTime.QuadPart -= 10000000;
	Li_Timer = liDueTime; 

#ifdef WTIMER_DEBUG
	wsprintf(szStr,"due %x %x <- %x %x",liDueTime.HighPart,liDueTime.LowPart,
		ftUtc.dwHighDateTime,ftUtc.dwLowDateTime);
	MyMessageBox(hParent,szStr,"TCY2",MB_OK);

	// ݎ擾
	GetLocalTime(&stCurrent);
#endif

	// ^C}[Zbg
	if(!LpSetWaitableTimer(HdTimer ,&liDueTime,0,MyTimerAPCProc,&hParent,TRUE)) goto L_ERR;
#ifndef WTIMER_DEBUG
	if(GetLastError() == ERROR_NOT_SUPPORTED) goto L_ERR; 
#endif

#ifdef WTIMER_DEBUG  
	wsprintf(szStr,"waitable timer set %d (%d/%d/%d %02d:%02d:%02d - %d sec)",
		HdWaitableTimerThread,

		stTime.wYear,
		stTime.wMonth,
		stTime.wDay,
		stTime.wHour,
		stTime.wMinute,
		stTime.wSecond,
		dwOffsetSec);
	WriteLog(szStr);
#endif

	//  ResetWaitableTimer() Ă΂
	// XbhςȂɂȂ̂ŃXe[^XWTSTAT_OFF
	// ̎̓[v΂B
	// (ɂ͂ƂrKvǎ蔲)
	if(DwWaitableTimerStatus != WTSTAT_OFF){
		
		// [vɓăVOî҂B
		DwWaitableTimerStatus = WTSTAT_ON;
		while(DwWaitableTimerStatus == WTSTAT_ON
			&& WaitForSingleObject(HdTimer, 50) == WAIT_TIMEOUT);
		SleepEx(50,TRUE); // Xbh alertable state  ɂB
		
	}
	
#ifdef WTIMER_DEBUG

	GetLocalTime(&sysTime);
	wsprintf(szStr,"%d/%d/%d %d:%d:%d -> %d/%d/%d %d:%d:%d [%d]",
		stCurrent.wYear,
		stCurrent.wMonth,
		stCurrent.wDay,
		stCurrent.wHour,
		stCurrent.wMinute,
		stCurrent.wSecond,
		
		sysTime.wYear,
		sysTime.wMonth,
		sysTime.wDay,
		sysTime.wHour,
		sysTime.wMinute,
		sysTime.wSecond,
		
		DwWaitableTimerStatus);
	
	if(WaitForSingleObject(HdTimer, 50) == WAIT_OBJECT_0)
		MyMessageBox(hParent,szStr,"wait I signal on",MB_OK);
	else MyMessageBox(hParent,szStr,"wait I signal off",MB_OK);
#endif

	bRet =  TRUE;
	
L_ERR:

	if(HdTimer){
		if(LpCancelWaitableTimer) LpCancelWaitableTimer(HdTimer); 
		CloseHandle(HdTimer);
	}
	HdTimer = NULL;
	HdWaitableTimerThread = NULL;
	DwWaitableTimerStatus = WTSTAT_OFF;

	return bRet;
}



//------------------------------------------
// WaitableTimer Zbg
BOOL SetWaitableTimer(HWND hWnd,
					  SYSTEMTIME stTime, // (local time)
					  DWORD dwOffsetSec  // b߂邩
					  ){
	
	static TIMERDATA timerData;
	static DWORD dwThreadId;
	
	if(HdWaitableTimerThread) return FALSE;
	
	timerData.hWnd = hWnd;
	timerData.stTime = stTime;
	timerData.dwOffsetSec = dwOffsetSec;
	
	if(!(HdWaitableTimerThread = CreateThread(NULL,0,
		(LPTHREAD_START_ROUTINE)SetWaitableTimerThread,
		(LPVOID)&timerData,
		0,(LPDWORD)&dwThreadId)))
	{
		MyMessageBox(hWnd,"ċN^C}[̋NɎs܂","LOCK ON",MB_OK|MB_ICONERROR);
		return FALSE;
	}
	
	return TRUE;
	
}

// EOF