// Win2k,XP  API g֐
// (c)2000-2003 tokai@main.eng.hokudai.ac.jp
//
// ƂgXgr[Ƃ
//  16bit J[ȏŎgp邱

#include <windows.h>

BOOL PrepareLayeredWindow(HWND); 
BOOL MySetLayeredWindowAttributes(HWND,COLORREF,BYTE,DWORD);
VOID UnprepareLayeredWindow();

#define WS_EX_LAYERED 0x80000
#define LWA_COLORKEY	1
#define LWA_ALPHA		2
typedef BOOL (WINAPI *SLWINATT)(HWND,COLORREF,BYTE,DWORD);

// O[p
HMODULE hModU32 = NULL;  // user32.dll ̃nh
BOOL BoolLoadU32 = FALSE;
SLWINATT pSetLayWinAtt;


// EBhE
BOOL PrepareLayeredWindow(HWND hWnd)
{
	if(!hModU32)
	{
		hModU32 = GetModuleHandle("user32.dll");
		BoolLoadU32 = FALSE;
		if(!hModU32) 
		{
			hModU32 = LoadLibrary("user32.dll");
			BoolLoadU32 = TRUE;
		}

		if(hModU32)
		{
			pSetLayWinAtt = 
				(SLWINATT)GetProcAddress(hModU32,"SetLayeredWindowAttributes");
			
			if(pSetLayWinAtt)
			{
				// X^C WS_EX_LAYERED Zbg
				SetWindowLong(hWnd, GWL_EXSTYLE,
					GetWindowLong(hWnd, GWL_EXSTYLE)|WS_EX_LAYERED);
				
				return TRUE;
			}
			else
			{
				if(BoolLoadU32) FreeLibrary(hModU32); 
				hModU32 = NULL;
				BoolLoadU32 = FALSE;
			}
		}
	}
	else return TRUE;
	
	return FALSE;
}


// n
VOID UnprepareLayeredWindow()
{
	if(hModU32 && BoolLoadU32) FreeLibrary(hModU32);
}


// 
BOOL MySetLayeredWindowAttributes(HWND hwnd,
								  COLORREF crKey,
								  BYTE bAlpha,        
								  DWORD dwFlags){
	if(hModU32) return pSetLayWinAtt(hwnd,crKey,bAlpha,dwFlags);
	else return FALSE;
}


//---------------------------------------------

#define LVM_FIRST               0x1000     
#define LVM_SETEXTENDEDLISTVIEWSTYLE (LVM_FIRST + 54)  
#define LVM_GETEXTENDEDLISTVIEWSTYLE (LVM_FIRST + 55)
#define LVS_EX_GRIDLINES        0x00000001
#define LVS_EX_TRACKSELECT      0x00000008
#define LVS_EX_FULLROWSELECT    0x00000020 
#define LVS_EX_ONECLICKACTIVATE 0x00000040
#define LVS_EX_UNDERLINEHOT     0x00000800

typedef struct _DllVersionInfo
{
    DWORD cbSize;
    DWORD dwMajorVersion;
    DWORD dwMinorVersion;
    DWORD dwBuildNumber;
    DWORD dwPlatformID;
}DLLVERSIONINFO;

typedef DWORD (WINAPI *DGVER)(DLLVERSIONINFO*);

// Xgr[g
BOOL ExListView(HWND hListWnd)
{
	HMODULE hComm32;
	DWORD dwStyle;
	DGVER pDllGetVersion = NULL;
	DLLVERSIONINFO dllVinfo;

	hComm32 = GetModuleHandle("comctl32.dll");
	
	if(hComm32)
	{
		// o[W 4.7 ȏȂg
		pDllGetVersion = (DGVER) GetProcAddress(hComm32,"DllGetVersion");
		if(pDllGetVersion)
		{
			dllVinfo.cbSize = sizeof(DLLVERSIONINFO);
			pDllGetVersion(&dllVinfo);
			if(dllVinfo.dwMajorVersion >= 5 
				|| (dllVinfo.dwMajorVersion == 4 && dllVinfo.dwMinorVersion >= 7)
				)
			{
				dwStyle = (DWORD)SendMessage(hListWnd,LVM_GETEXTENDEDLISTVIEWSTYLE,0,0);
				dwStyle |= LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_ONECLICKACTIVATE | LVS_EX_UNDERLINEHOT;
				SendMessage(hListWnd,LVM_SETEXTENDEDLISTVIEWSTYLE,0,dwStyle);
			}
		}
	}
	
	return FALSE;
}



// EOF